      subroutine felev(xe,te)
c New 991214 : Included the wpdxfe-terms in emsfei-emsfeiv,emsf and eml
c
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      logical skip
      character*20 chc,chh
      common/ctpar/tday,dts,iss,iss1,itd
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cnlev/nlev(mie,mion),nlevm(mie,mion),nlevfe(mion,mid),
     &     nlevfe1m,nlevfe2m,nlevfe3m,nlevfe4m
      common/depthind/id
      common/cden/den
      common/checo/heat,cool,co(mie,mion),emstot,
     &     pheats,pheat(mie,mion),phex,cov(115),hev(35),
     &     comg1(nl,nl),cosi1(nl,nl),chc(115),chh(35),klcm,klhm
c     &     chch(105),klchm
c     &     hphi,hphei,hpoi,hpcaii,hpfei,hpfeii,hpfeiii,hpfeiv,
c     &     chi,crechi,chei,crechei,coci1,coci2,ccii1,ccii2,c221,
c     &     conii1,conii2,coniii1,coniii2,coi,coifs,crecoi,
c     &     coiii1,coiii2,coneiii1,coneiii2,
c     &     c411,c412,cosiii1,cosiii2,cosuli1,cosuli2,csul2,c1222,
c     &     cosuliii1,cosuliii2,cocaii,creccaii,
c     &     cfei1,cfei,crecfei,cfeii1,cfeii,crecfeii,
c     &     cfeiii1,cfeiii,crecfeiii,cfeiv,crecfeiv
c      common/cmlev/em(mie,mion,nl,nl),wobs(mie,mion,nl,nl),
      common/cmlev/emo1(nl,nl),wobso1(nl,nl),
     &     emhe1(nl,nl),wobshe1(nl,nl),
     &     emca2(nl,nl),wobsca2(nl,nl),
     &     emf1(nlf1,nlf1),emf2(nlf2,nlf2),emf3(nlf3,nlf3),
     &     emf4(nlf4,nlf4),wobsf1(nlf1,nlf1),wobsf2(nlf2,nlf2),
     &     wobsf3(nlf3,nlf3),wobsf4(nlf4,nlf4),
     &     emh(nm,nm),wobsh(nm,nm),wobstwop,emtwop,wobslya,emlya
      common/crecph/reco(mie,mion,nl),ph(mie,mion,nl),gh(mie,mion,nl),
     &     recof1(nlf1),recof2(nlf2),recof3(nlf3),recof4(nlf4),
     &     phh1(nmax),ghh1(nmax),
     &     phf1(nlf1),phf2(nlf2),phf3(nlf3),phf4(nlf4),
     &     ghf1(nlf1),ghf2(nlf2),ghf3(nlf3),ghf4(nlf4),
     &     recofr(mie,mion),phto(mie,mion),alsi,pennc
      common/cfedat/cf1(nlf1,nlf1),cf2(nlf2,nlf2),cf3(nlf3,nlf3),
     &     cf4(nlf4,nlf4),cif1(nlf1),cif2(nlf2),cif3(nlf3),cif4(nlf4),
     &     gf1(nlf1),gf2(nlf2),gf3(nlf3),gf4(nlf4),ef1(nlf1),ef2(nlf2),
     &     ef3(nlf3),ef4(nlf4),af1(nlf1,nlf1),af2(nlf2,nlf2),
     &     af3(nlf3,nlf3),af4(nlf4,nlf4),cpf2(3,3)
      common/cionpot/e00(mie,mion)
      common/cfeem/kupf1(16000),klof1(16000),kupf2(2300),klof2(2300),
     &     kupf3(1000),klof3(1000),kupf4(250),klof4(250),
     &     kfel(mion),kfer(mion)
      common/cinitf/initfe
      common/cwpdx/wpdxhe1(nl,nl),wpdxo1(nl,nl),wpdxca2(nl,nl),
     &     wpdxh1(nm,nm),
     &     wpdxfe1(nlf1,nlf1),wpdxfe2(nlf2,nlf2),
     &     wpdxfe3(nlf3,nlf3),wpdxfe4(nlf4,nlf4)
c
      dimension xi(nlf),flfb(nlf)
      dimension colostfe(4),helostfe(4),emlostfe(4)
c
      common/csav4/zfold(4,mid),denfo(4,mid),xefo(4,mid),
     &     tefo(4,mid)
c
      data tol/0.001/
      data tolfe/0.05/
c
c  this routine gives the number of levels in Fe I,II,III,IV
c
c  calculate multi-level atom only if xe,te,den,z, has changed 
c  more than tolfe
c
c      goto 999
      if (initfe.eq.0) then
         initfe=1
         do ion=1,4
            do i=1,mid
               zfold(ion,i)=0.
               denfo(ion,i)=0.
               xefo(ion,i)=0.
               tefo(ion,i)=0.
            enddo
         enddo
      endif
c
      if (ab(iefe).gt.0.) then
c
         ie=iefe
c
c  Fe I multilevel atom
c
         ion=1
         z=ab(iefe)*xa(iefe,ion)
c
         skip=.true.
c
         fxe=abs(xe-xefo(ion,id))/xe
         fte=abs(te-tefo(ion,id))/te
         fden=abs(den-denfo(ion,id))/den
         fz=abs(z-zfold(ion,id))/z
c
         if (fxe.ge.tolfe) skip=.false.
         if (fte.ge.tolfe) skip=.false.
         if (fden.ge.tolfe) skip=.false.
         if (fz.ge.tolfe) skip=.false.
c
         if (.not.skip) then
            n1=nlevm(iefe,ion)
            call multinc1(iefe,ion,z,den,xe,te,n1,xi)
            nmin=20
c----------------------------------------------------
c
c  cooling and heating :
c
            cfei=0.
            crecfei=0.
            hpfei=0.
c
            do i=1,n1
               do j=1,n1
                  cfei=cfei+emf1(i,j)
               enddo
            enddo
c     recombination cooling and emission in continua 
c     assumes OTS-approx. for n=1
            do k=2,n1
               reccon=ab(ie)*xa(iefe,2)*recof1(k)
               crecfei=crecfei+reccon*1.38e-16*te
               flfb(k)=reccon*((e00(ie,ion)-ef1(k))*1.602e-12
     &              +1.38e-16*te)
               phheat=ab(ie)*xi(k)*ghf1(k)/den
               hpfei=hpfei + phheat
            enddo
c
            cofei=cfei+crecfei
            if (abs(cofei/cool).lt.tol) then
               nc=nmin
            else
               recc=ab(iefe)*xa(iefe,2)*1.38e-16*te
               corl=0.
               nc=nmin
               do i=n1,nmin,-1
                  corl=corl+recc*recof1(i)
                  im1=i-1
                  do j=im1,1,-1
                     corl=corl+emf1(i,j)
                  enddo
                  if (abs(corl/cool).gt.tol) then
                     nc=i+1
                     if (nc.gt.n1) nc=n1
                     goto 91
                  endif
               enddo
 91            continue
            endif
c
            if ((hpfei/heat).lt.tol) then
               nh=nmin
            else
               hef=0.
               nh=nmin
               do k=n1,nmin,-1
                  hef=hef+ab(iefe)*xi(k)*ghf1(k)/den
                  if ((hef/heat).gt.tol) then
                     nh=k+1
                     if (nh.gt.n1) nh=n1
                     goto 92
                  endif
               enddo
 92            continue
            endif
c
c  emission :
c
c  line emission ; fe i ; emsfei
c
            emsfei=0.
            do k=1,kfel(ion)
               j=kupf1(k)
               i=klof1(k)
               emsfei=emsfei+(wobsf1(j,i)+wpdxfe1(j,i))/xe
            enddo
c
c  recomb. emission (on the spot) ; emrecfei
c
            emrec=0.
            do i=2,n1
               emrec=emrec+flfb(i)
            enddo
c
            if (((emsfei+emrec)/emstot).lt.tol) then
               nem=nmin
            else
               emfs=0.
               nem=nmin
               do i=n1,nmin,-1
                  emfs=emfs+flfb(i)
                  im1=i-1
                  do j=im1,1,-1
                     emfs=emfs+(wobsf1(i,j)+wpdxfe1(j,i))/xe
                  enddo
                  if ((emfs/emstot).gt.tol) then
                     nem=i+1
                     if (nem.gt.n1) nem=n1
                     goto 93
                  endif
               enddo
 93            continue
            endif
c
            nlevfe(ion,id)=max(nc,nh,nem)
c
            col=0.
            hel=0.
            do i=nlevfe(ion,id)+1,n1
               do j=1,n1
                  col=col+emf1(i,j)
               enddo
            enddo
c
            do k=nlevfe(ion,id)+1,n1
               reccon=ab(ie)*xa(iefe,2)*recof1(k)
               col=col+reccon*1.38e-16*te
               phheat=ab(ie)*xi(k)*ghf1(k)/den
               hel=hel + phheat
            enddo
c
            eml=0.
            do k=1,kfel(ion)
               j=kupf1(k)
               i=klof1(k)
               if (j.gt.nlevfe(ion,id)) 
     &              eml=eml+(wobsf1(j,i)+wpdxfe1(j,i))/xe
            enddo
c
            do i=nlevfe(ion,id)+1,n1
               eml=eml+flfb(i)
            enddo
c
            colostfe(1)=col/cool
            helostfe(1)=hel/heat
            emlostfe(1)=eml/emstot
c
            xefo(ion,id)=xe
            tefo(ion,id)=te
            denfo(ion,id)=den
            zfold(ion,id)=z
c
cqcq run 70.6.1
c            write(66,701) ' Fe I ',tday,id,xa(iefe,1),nlevfe(1,id),
c     &           colostfe(1),helostfe(1),emlostfe(1)
c
         endif
c----------------------------------------------------
c
c  Fe II multilevel atom
c
         ion=2
         z=ab(iefe)*xa(iefe,ion)
c
         skip=.true.
c
         fxe=abs(xe-xefo(ion,id))/xe
         fte=abs(te-tefo(ion,id))/te
         fden=abs(den-denfo(ion,id))/den
         fz=abs(z-zfold(ion,id))/z
c
         if (fxe.ge.tolfe) skip=.false.
         if (fte.ge.tolfe) skip=.false.
         if (fden.ge.tolfe) skip=.false.
         if (fz.ge.tolfe) skip=.false.
c
         if (.not.skip) then
            n2=nlevm(iefe,ion)
            call multinc1(iefe,ion,z,den,xe,te,n2,xi)
            nmin=23
c            nmin=90
c----------------------------------------------------
c
c  cooling and heating :
c
            cfeii=0.
            crecfeii=0.
            hpfeii=0.
c                                        
            do i=1,n2
               do j=1,n2
                  cfeii=cfeii+emf2(i,j)
               enddo
            enddo
c     recombination cooling and emission in continua 
c     assumes OTS-approx. for n=1
            do k=2,n2
               reccon=ab(ie)*xa(iefe,3)*recof2(k)
               crecfeii=crecfeii+reccon*1.38e-16*te
               flfb(k)=reccon*((e00(ie,ion)-ef2(k))*1.602e-12
     &              +1.38e-16*te)
               phheat=ab(ie)*xi(k)*ghf2(k)/den
               hpfeii=hpfeii + phheat
            enddo
c
            cofeii=cfeii+crecfeii
            if (abs(cofeii/cool).lt.tol) then
               nc=nmin
            else
               recc=ab(iefe)*xa(iefe,3)*1.38e-16*te
               corl=0.
               nc=nmin
               do i=n2,nmin,-1
                  corl=corl+recc*recof2(i)
                  im1=i-1
                  do j=im1,1,-1
                     corl=corl+emf2(i,j)
                  enddo
                  if (abs(corl/cool).gt.tol) then
                     nc=i+1
                     if (nc.gt.n2) nc=n2
                     goto 94
                  endif
               enddo
 94            continue
            endif
c
            if ((hpfeii/heat).lt.tol) then
               nh=nmin
            else
               hef=0.
               nh=nmin
               do k=n2,nmin,-1
                  hef=hef+ab(iefe)*xi(k)*ghf2(k)/den
                  if ((hef/heat).gt.tol) then
                     nh=k+1
                     if (nh.gt.n2) nh=n2
                     goto 95
                  endif
               enddo
 95            continue
            endif
c
c  emission :
c
c  line emission ; fe ii ; emsfeii
c
            emsfeii=0.
            do k=1,kfel(ion)
               j=kupf2(k)
               i=klof2(k)
cqcq last-run 99
c               emsfeii=emsfeii+wobsf2(j,i)/xe
               emsfeii=emsfeii+(wobsf2(j,i)+wpdxfe2(j,i))/xe
            enddo
c
c  recomb. emission (on the spot) ; emrecfei
c
            emrec=0.
            do i=2,n2
               emrec=emrec+flfb(i)
            enddo
c
            if (((emsfeii+emrec)/emstot).lt.tol) then
               nem=nmin
            else
               emfs=0.
               nem=nmin
               do i=n2,nmin,-1
                  emfs=emfs+flfb(i)
                  im1=i-1
                  do j=im1,1,-1
                     emfs=emfs+(wobsf2(i,j)+wpdxfe2(j,i))/xe
                  enddo
                  if ((emfs/emstot).gt.tol) then
                     nem=i+1
                     if (nem.gt.n2) nem=n2
                     goto 96
                  endif
               enddo
 96            continue
            endif
c
            nlevfe(ion,id)=max(nc,nh,nem)
c                                        
            col=0.
            hel=0.
            do i=nlevfe(ion,id)+1,n2
               do j=1,n2
                  col=col+emf2(i,j)
               enddo
            enddo
c
            do k=nlevfe(ion,id)+1,n2
               reccon=ab(ie)*xa(iefe,3)*recof2(k)
               col=col+reccon*1.38e-16*te
               phheat=ab(ie)*xi(k)*ghf2(k)/den
               hel=hel + phheat
            enddo
c
            eml=0.
            do k=1,kfel(ion)
               j=kupf2(k)
               i=klof2(k)
               if (j.gt.nlevfe(ion,id)) 
     &              eml=eml+(wobsf2(j,i)+wpdxfe2(j,i))/xe
            enddo
c
            do i=nlevfe(ion,id)+1,n2
               eml=eml+flfb(i)
            enddo
c
            colostfe(2)=col/cool
            helostfe(2)=hel/heat
            emlostfe(2)=eml/emstot
c
            xefo(ion,id)=xe
            tefo(ion,id)=te
            denfo(ion,id)=den
            zfold(ion,id)=z
c
c            write(66,701) ' Fe II ',tday,id,xa(iefe,2),nlevfe(2,id),
c     &           colostfe(2),helostfe(2),emlostfe(2)
c
         endif
c----------------------------------------------------
c
c  Fe III multilevel atom
c
         ion=3
         z=ab(iefe)*xa(iefe,ion)
c
         skip=.true.
c
         fxe=abs(xe-xefo(ion,id))/xe
         fte=abs(te-tefo(ion,id))/te
         fden=abs(den-denfo(ion,id))/den
         fz=abs(z-zfold(ion,id))/z
c
         if (fxe.ge.tolfe) skip=.false.
         if (fte.ge.tolfe) skip=.false.
         if (fden.ge.tolfe) skip=.false.
         if (fz.ge.tolfe) skip=.false.
c
         if (.not.skip) then
            n3=nlevm(iefe,ion)
            call multinc1(iefe,ion,z,den,xe,te,n3,xi)
            nmin=26
c----------------------------------------------------
c
c  cooling and heating :
c
            cfeiii=0.
            crecfeiii=0.
            hpfeiii=0.
c
            do i=1,n3
               do j=1,n3
                  cfeiii=cfeiii+emf3(i,j)
               enddo
            enddo
c     recombination cooling and emission in continua 
c     assumes OTS-approx. for n=1
            do k=2,n3
               reccon=ab(ie)*xa(iefe,4)*recof3(k)
               crecfeiii=crecfeiii+reccon*1.38e-16*te
               flfb(k)=reccon*((e00(ie,ion)-ef3(k))*1.602e-12
     &              +1.38e-16*te)
               phheat=ab(ie)*xi(k)*ghf3(k)/den
               hpfeiii=hpfeiii + phheat
            enddo
c
            cofeiii=cfeiii+crecfeiii
            if (abs(cofeiii/cool).lt.tol) then
               nc=nmin
            else
               recc=ab(iefe)*xa(iefe,4)*1.38e-16*te
               corl=0.
               nc=nmin
               do i=n3,nmin,-1
                  corl=corl+recc*recof3(i)
                  im1=i-1
                  do j=im1,1,-1
                     corl=corl+emf3(i,j)
                  enddo
                  if (abs(corl/cool).gt.tol) then
                     nc=i+1
                     if (nc.gt.n3) nc=n3
                     goto 97
                  endif
               enddo
 97            continue
            endif
c
            if ((hpfeiii/heat).lt.tol) then
               nh=nmin
            else
               hef=0.
               nh=nmin
               do k=n3,nmin,-1
                  hef=hef+ab(iefe)*xi(k)*ghf3(k)/den
                  if ((hef/heat).gt.tol) then
                     nh=k+1
                     if (nh.gt.n3) nh=n3
                     goto 98
                  endif
               enddo
 98            continue
            endif
c
c  emission :
c
c  line emission ; fe iii ; emsfeiii
c
            emsfeiii=0.
            do k=1,kfel(ion)
               j=kupf3(k)
               i=klof3(k)
               emsfeiii=emsfeiii+(wobsf3(j,i)+wpdxfe3(j,i))/xe
            enddo
c
c  recomb. emission (on the spot) ; emrecfei
c
            emrec=0.
            do i=2,n3
               emrec=emrec+flfb(i)
            enddo
c
            if (((emsfeiii+emrec)/emstot).lt.tol) then
               nem=nmin
            else
               emfs=0.
               nem=nmin
               do i=n3,nmin,-1
                  emfs=emfs+flfb(i)
                  im1=i-1
                  do j=im1,1,-1
                     emfs=emfs+(wobsf3(i,j)+wpdxfe3(j,i))/xe
                  enddo
                  if ((emfs/emstot).gt.tol) then
                     nem=i+1
                     if (nem.gt.n3) nem=n3
                     goto 99
                  endif
               enddo
 99            continue
            endif
c
            nlevfe(ion,id)=max(nc,nh,nem)
c                                        
            col=0.
            hel=0.
            do i=nlevfe(ion,id)+1,n3
               do j=1,n3
                  col=col+emf3(i,j)
               enddo
            enddo
c
            do k=nlevfe(ion,id)+1,n3
               reccon=ab(ie)*xa(iefe,4)*recof3(k)
               col=col+reccon*1.38e-16*te
               phheat=ab(ie)*xi(k)*ghf3(k)/den
               hel=hel + phheat
            enddo
c
            eml=0.
            do k=1,kfel(ion)
               j=kupf3(k)
               i=klof3(k)
               if (j.gt.nlevfe(ion,id)) 
     &              eml=eml+(wobsf3(j,i)+wpdxfe3(j,i))/xe
            enddo
c
            do i=nlevfe(ion,id)+1,n3
               eml=eml+flfb(i)
            enddo
c
            colostfe(3)=col/cool
            helostfe(3)=hel/heat
            emlostfe(3)=eml/emstot
c
            xefo(ion,id)=xe
            tefo(ion,id)=te
            denfo(ion,id)=den
            zfold(ion,id)=z
c
c            write(66,701) ' Fe III ',tday,id,xa(iefe,3),nlevfe(3,id),
c     &           colostfe(3),helostfe(3),emlostfe(3)
c
         endif
c----------------------------------------------------
c
c  Fe IV multilevel atom
c
         ion=4
         z=ab(iefe)*xa(iefe,ion)
c
         skip=.true.
c
         fxe=abs(xe-xefo(ion,id))/xe
         fte=abs(te-tefo(ion,id))/te
         fden=abs(den-denfo(ion,id))/den
         fz=abs(z-zfold(ion,id))/z
c
         if (fxe.ge.tolfe) skip=.false.
         if (fte.ge.tolfe) skip=.false.
         if (fden.ge.tolfe) skip=.false.
         if (fz.ge.tolfe) skip=.false.
c
         if (.not.skip) then
            n4=nlevm(iefe,ion)
            call multinc1(iefe,ion,z,den,xe,te,n4,xi)
            nmin=24
c----------------------------------------------------
c
c  cooling and heating :
c
            cfeiv=0.
            crecfeiv=0.
            hpfeiv=0.
c
            do i=1,n4
               do j=1,n4
                  cfeiv=cfeiv+emf4(i,j)
               enddo
            enddo
c     recombination cooling and emission in continua 
c     assumes OTS-approx. for n=1
            do k=2,n4
               reccon=ab(ie)*xa(iefe,5)*recof4(k)
               crecfeiv=crecfeiv+reccon*1.38e-16*te
               flfb(k)=reccon*((e00(ie,ion)-ef4(k))*1.602e-12
     &              +1.38e-16*te)
               phheat=ab(ie)*xi(k)*ghf4(k)/den
               hpfeiv=hpfeiv + phheat
            enddo
c
            cofeiv=cfeiv+crecfeiv
            if (abs(cofeiv/cool).lt.tol) then
               nc=nmin
            else
               recc=ab(iefe)*xa(iefe,5)*1.38e-16*te
               corl=0.
               nc=nmin
               do i=n4,nmin,-1
                  corl=corl+recc*recof4(i)
                  im1=i-1
                  do j=im1,1,-1
                     corl=corl+emf4(i,j)
                  enddo
                  if (abs(corl/cool).gt.tol) then
                     nc=i+1
                     if (nc.gt.n4) nc=n4
                     goto 100
                  endif
               enddo
 100           continue
            endif
c
            if ((hpfeiv/heat).lt.tol) then
               nh=nmin
            else
               hef=0.
               nh=nmin
               do k=n4,nmin,-1
                  hef=hef+ab(iefe)*xi(k)*ghf4(k)/den
                  if ((hef/heat).gt.tol) then
                     nh=k+1
                     if (nh.gt.n4) nh=n4
                     goto 101
                  endif
               enddo
 101           continue
            endif
c
c  emission :
c
c  line emission ; fe iv ; emsfeiv
c
            emsfeiv=0.
            do k=1,kfel(ion)
               j=kupf4(k)
               i=klof4(k)
               emsfeiv=emsfeiv+(wobsf4(j,i)+wpdxfe4(j,i))/xe
            enddo
c
c  recomb. emission (on the spot) ; emrecfei
c
            emrec=0.
            do i=2,n4
               emrec=emrec+flfb(i)
            enddo
c
            if (((emsfeiv+emrec)/emstot).lt.tol) then
               nem=nmin
            else
               emfs=0.
               nem=nmin
               do i=n4,nmin,-1
                  emfs=emfs+flfb(i)
                  im1=i-1
                  do j=im1,1,-1
                     emfs=emfs+(wobsf4(i,j)+wpdxfe4(j,i))/xe
                  enddo
                  if ((emfs/emstot).gt.tol) then
                     nem=i+1
                     if (nem.gt.n4) nem=n4
                     goto 102
                  endif
               enddo
 102           continue
            endif
c
            nlevfe(ion,id)=max(nc,nh,nem)
c                                        
            col=0.
            hel=0.
            do i=nlevfe(ion,id)+1,n4
               do j=1,n4
                  col=col+emf4(i,j)
               enddo
            enddo
c                                        
            do k=nlevfe(ion,id)+1,n4
               reccon=ab(ie)*xa(iefe,5)*recof4(k)
               col=col+reccon*1.38e-16*te
               phheat=ab(ie)*xi(k)*ghf4(k)/den
               hel=hel + phheat
            enddo
c
            eml=0.
            do k=1,kfel(ion)
               j=kupf4(k)
               i=klof4(k)
               if (j.gt.nlevfe(ion,id)) 
     &              eml=eml+(wobsf4(j,i)+wpdxfe4(j,i))/xe
            enddo
c
            do i=nlevfe(ion,id)+1,n4
               eml=eml+flfb(i)
            enddo
c
            colostfe(4)=col/cool
            helostfe(4)=hel/heat
            emlostfe(4)=eml/emstot
c
            xefo(ion,id)=xe
            tefo(ion,id)=te
            denfo(ion,id)=den
            zfold(ion,id)=z
c
c            write(66,701) ' Fe IV ',tday,id,xa(iefe,4),nlevfe(4,id),
c     &           colostfe(4),helostfe(4),emlostfe(4)
c                                        
         endif
c
      endif
c
c 999  continue
c
 701  format(a8,f10.2,i5,1pe10.2,i5,1pe12.4,3e12.4)
      return
      end
