      subroutine abund87acl
      implicit real*8 (a-h,o-z)
cmion abund
c
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      common/ciz/iz
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
c
c  iz is the number of the zone in the 10h-model
c
c  iz = 1 ; fe - he
c  iz = 2 ; si - s
c  iz = 3 ; o-si-s
c  iz = 4 ; o-c
c  iz = 5 ; he
c  iz = 6 ; h
c
      open(13,file='INPUT/iorabin',status='old')
      do l=1,6
      read(13,*) iz0
c
      do ie=1,15
        read(13,*) abqq
        if(iz.eq.iz0) then
          ab(ie)=abqq
c  correct to a total metalicity of 1/3 for LMC in the hydrogen zone
          if(iz.eq.6.and.ie.ge.3)  ab(ie)=abqq/3. 
c  correct Fe to 1/3 solar for LMC in all zones outside the si core
          if(iz.ge.3.and.iz.le.5.and.ie.ge.13)  ab(ie)=abqq/3. 
        endif
      enddo
      enddo
c  normalize abundances to 1.
      absum=0.
      do ie=1,15
        absum=absum+ab(ie)
      enddo
      do ie=1,15
        ab(ie)=ab(ie)/absum
      enddo
c
      close(13)
c
      return
      end



      subroutine abund87a
      implicit real*8 (a-h,o-z)
cmion abund
c
c  the abundances of nickel and cobolt are calculated separately 
c  in subroutine abir for zones where ab(iefe)>0.01 , that is for 
c  the fe-he and the si-s zones. These zones are assumed to contain 
c  the radioactive Ni and Co.
c  For the remaining zones, assumed to contain the stable Ni and Co,
c  the abundances are given here. 
c
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
c
c  iz is the number of the zone in the 10h-model
c
c  iz = 1 ; fe - he
c  iz = 2 ; si - s
c  iz = 3 ; o-si-s
c  iz = 4 ; o-c
c  iz = 5 ; he
c  iz = 6 ; h
c
      do iz=1,10
         do ie=1,mie
            abmod(iz,ie)=0.d0
         enddo
      enddo
c
cqcq run 19.6 ; change the C to O in the He-zone
c      open(13,file='INPUT/iorabin.wos.c_o',status='old')
cqcq run 20; run 16.4; run 22.1; run 20.5; run 30; run 40; run 40.1
cqcq run 50; run 50.5; run 50.8; run 60.1; run 60.2; run 60.4
cqcq run 60.5; run 60.6; run 60.7; run 60.8; run 70.1; run 70.2
cqcq run 70.3; run 70.4; run 70.5; run 70.6; run 70.7
cqcq run 80.1; run 80.2; run 80.3; run 80.4; run 80.5; run 80.6
cqcq run 80.7; run 70.8; run 70.9 ; last-run 99; run 102
cqcq run 71.2; run 71.3; run 72.1; run 80.8; run 72.2; run 72.3
cqcq run 73.1; run 73.2; run 73.3
cqcq run 74.1; run 74.2; run 74.3; run 74.4; run 74.5; run 74.6
cqcq run 75.1; run 75.2; run 75.3; run 75.4; run 75.5; run 75.6
cqcq run 76.5; run 78.1; run 78.2; run 78.3; run f01
cqcq run 170; run 171; run 172; run 173; run 174
      open(13,file='INPUT/iorabin.wos',status='old')
cqcq run 99
c      open(13,file='INPUT/iorabin.wos.99',status='old')
cqcq run 21; run 31 ; run 41 ; run 41.2 ; run 41.4; run 41.6; run 41.7
cqcq run 61.1
c      open(13,file='INPUT/iorabin.nom',status='old')
cqcq run 41.5
c      open(13,file='INPUT/iorabin.nom.415',status='old')
cqcq run 31.1; 31.2 ; run 41.3
c      open(13,file='INPUT/iorabin.nom.si',status='old')
cqcq run 19.7 ; He-N zone instead of He-C zone; run 40.2
c      open(13,file='INPUT/iorabin.wos.he_n',status='old')
      do iz=1,6
         read(13,*) iz0
         absum=0.
c
         do ie=1,15
            read(13,*) abqq
            abmod(iz0,ie)=abqq
c  correct to a total metalicity of 1/3 for LMC in the hydrogen zone
c            if(iz0.eq.6.and.ie.ge.3)  abmod(iz0,ie)=abqq/3. 
c  correct Fe to 1/3 solar for LMC in all zones outside the si core
c            if(iz0.ge.3.and.iz0.le.5.and.ie.ge.13) abmod(iz0,ie)=abqq/3. 
            absum=absum+abmod(iz0,ie)
         enddo
c
         ameanmod(iz0)=0.
         do ie=1,15
            ameanmod(iz0)=ameanmod(iz0)+(abmod(iz0,ie)/absum)*aw(ie)
            abmod(iz0,ie)=abmod(iz0,ie)/absum
         enddo
      enddo
c
      close(13)
c
      return
      end



      subroutine abund93j
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      character*8 rlab
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
c
      open(35,file='abin93j',status='old')
c
      do iz=1,10
         do ie=1,mie
            abmod(iz,ie)=0.d0
         enddo
      enddo
c
      do iz=1,8
         read(35,*) iz0
         absum=0.
         do ie=1,15
            read(35,*) abqq
            abmod(iz0,ie)=abqq
            absum=absum+abqq
         enddo
c
         ameanmod(iz)=0.
         do ie=1,15
            ameanmod(iz)=ameanmod(iz)+(abmod(iz,ie)/absum)*aw(ie)
            abmod(iz0,ie)=abmod(iz0,ie)/absum
         enddo
      enddo
c
      close(35)
 701  format(a)
      return
      end



      subroutine modinold
      implicit real*8 (a-h,o-z)
      real*8 mni56,mni57,mni5860,mti44,msun
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      include 'INCLUDE/DATMOL.NOMOL'
      character*8 rlab,zlab,zlabq
      character*4 num
      common/clab/num
      common/ctpar/tday,dts,iss,iss1,itd
      common/csn/i87acl,i87a,i93j,isn
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      common/cphionfl/iflphi
      dimension dmfe(mid)
      dimension vel1z(10),vel2z(10),iq(10),ns(10)
      dimension zmass(10),zlab(10),fill(10),zden(10)
      data amu/1.64e-24/,pi/3.14159/,msun/1.989e33/
      include 'INCLUDE/OUTDIR'
c
      do i=1,mid
         vrmod(i)=0.
         rmod(i)=0.
         rlab(i)='        '
         dmmod(i)=0.
         izmod(i)=0
      enddo
c
      if (i87a.eq.1) then
         open(35,file='modin87a.osis',status='old')
      elseif (i93j.eq.1) then
         open(35,file='modin93j',status='old')
      endif
c
      read(35,*) tdmod
      read(35,*) izc
      read(35,*) mix
      read(35,*) nsmix
      read(35,*) vmin
      read(35,*) vcore
      read(35,*) mni56
      read(35,*) mni57
      read(35,*) mti44
      mixm=mix
c  read the core regions
      do iz=1,izc
         read(35,706) iz0,zmass(iz),vel1z(iz),vel2z(iz),fill(iz),
     &        zlab(iz),ns(iz),iq(iz)
         if (iz.ne.iz0) then
            write(50,*) 'Something strange in mod87a !'
            stop
         endif
      enddo
c
      do iz=1,izc
         if (iq(iz).eq.1) then
            iz1=iz
            goto 91
         endif
      enddo
 91   continue
c
      ir=0
      c1=1.d5*tdmod*8.64d4
      s=1/3.
      if (mixm.eq.0) then
c non-mixed model
         do iz=1,izc
            if (iq(iz).eq.1) then
               zm=zmass(iz)/ns(iz)
               v1=vel1z(iz)
               v2=vel2z(iz)
               r1=v1*c1
               r2=v2*c1
               volz=4.*pi*(r2**3-r1**3)/3.
               dvolv=(v2**3-v1**3)/ns(iz)
               ameanz=ameanmod(iz)
               zden(iz)=(zmass(iz)*msun)/(volz*ameanz*amu)
c
               do i=1,ns(iz)
                  ir=ir+1
                  if (ir.eq.1) then
                     rmod(ir)=r1
                     vrmod(ir)=v1
                  endif
                  if (i.eq.ns(iz)) then
                     vrmod(ir+1)=v2
                     rmod(ir+1)=r2
                  else
                     vrmod(ir+1)=(vrmod(ir)**3+dvolv)**s
                     rmod(ir+1)=vrmod(ir+1)*c1
                  endif
                  izmod(ir)=iz
                  rlab(ir)=zlab(iz)
                  denmod(ir)=zden(iz)
                  dmmod(ir)=zm
               enddo
            endif
         enddo
      elseif (mixm.eq.1) then
c  mixed model
         vtot=4.*pi*(c1**3)*(vcore**3-vmin**3)/3
c
         fsum=0.
         do iz=1,izc
            if (iq(iz).eq.1) fsum=fsum+fill(iz)
         enddo
c                                        
         do iz=1,izc
            if (iq(iz).eq.1) then
               fill(iz)=fill(iz)/fsum
               zden(iz)=(zmass(iz)*msun)/
     &              (vtot*fill(iz)*ameanmod(iz)*amu)
            endif
         enddo
c
         do iz=1,izc
            if (iq(iz).eq.1) then
               if (ns(iz).ne.nsmix) then
                  write(50,*) ' model problem ! '
                  stop
               endif
            endif
         enddo
c
         do ishell=1,nsmix
c  the fe-he composition (iz=iz1) in the inner, central part (0 - 500 km/s).
            iz=iz1
            if (iq(iz).eq.1) then
               ir=ir+1
               if (ir.eq.1) then
                  v1=vmin
                  r1=v1*c1
c
                  if (ns(iz).gt.1) then
                     v2=500.
                     r2=v2*c1
c
                     volz=4.*pi*(r2**3-r1**3)/3.
                     dmmod(ir)=(zden(iz)*volz*ameanmod(iz)*amu)/msun
                     if (dmmod(ir).ge.zmass(iz)) then
                        write(50,*) 'fe-zone trouble in the input model'
                        stop
                     endif
                     zmfe=(zmass(iz)-dmmod(ir))/(ns(iz)-1)
                  elseif (ns(iz).eq.1) then
                     volz=(zmass(iz)*msun)/(zden(iz)*ameanmod(iz)*amu)
                     v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
                     if (v2.lt.500.) then
                        write(50,*) 'fe-zone trouble in the input model'
                        stop
                     endif
                     r2=v2*c1
                     dmmod(ir)=zmass(iz)
                  endif
                  vrmod(ir)=v1
                  rmod(ir)=r1
               else
                  dmmod(ir)=zmfe
                  v1=vrmod(ir)
                  volz=(zmfe*msun)/(zden(iz)*ameanmod(iz)*amu)
                  v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
                  r2=v2*c1
               endif
c
               vrmod(ir+1)=v2
               rmod(ir+1)=r2
               izmod(ir)=iz
               rlab(ir)=zlab(iz)
               denmod(ir)=zden(iz)
            endif

            do iz=iz1+1,izc
               if (iq(iz).eq.1) then
                  ir=ir+1
                  v1=vrmod(ir)
                  r1=rmod(ir)
                  dmmod(ir)=zmass(iz)/ns(iz)
c
                  volz=(dmmod(ir)*msun)/(zden(iz)*ameanmod(iz)*amu)
                  v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
                  r2=v2*c1
c
                  vrmod(ir+1)=v2
                  rmod(ir+1)=r2
                  izmod(ir)=iz
                  rlab(ir)=zlab(iz)
                  denmod(ir)=zden(iz)
               endif
            enddo
         enddo
c
      endif
      nrc=ir
c  the envelope region 
      zmenv=0.
      do i=1,100
         read(35,706,end=9,err=9) iz,zmassq,vel1zq,vel2zq,fillq,
     &        zlabq,nsq,iqq
         izenv=iz
         if (iqq.eq.1) then
            ir=ir+1
            izmod(ir)=iz
            rlab(ir)=zlabq
            dmmod(ir)=zmassq
            vrmod(ir+1)=vel2zq
            rmod(ir+1)=vrmod(ir+1)*c1
            r1=vel1zq*c1
            r2=vel2zq*c1
            volz=4.*pi*(r2**3-r1**3)/3.
            denmod(ir)=(zmassq*msun)/(volz*ameanmod(iz)*amu)
            zmenv=zmenv+zmassq
         endif
      enddo
 9    continue
      nrmod=ir
c
      close(35)
c
c  Estimate the masses of ni56, ni57, and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=ameanmod(iz)
         if (abfe.ge.0.01) then
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
c  izm is the last shell containing radiactive elements
c
      if (sumfe.le.0.) then
         izm=0
         do ir=1,nrmod
            dmzni56(ir)=0.
            dmzni57(ir)=0.
            dmzti44(ir)=0.
         enddo
      else
         izm=nrmod
         do ir=1,nrmod
            dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
            dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
            dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
            if (dmzni56(ir).gt.0.) izm=ir
            if (dmzni57(ir).gt.0.) izm=ir
            if (dmzti44(ir).gt.0.) izm=ir
         enddo
      endif
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
      enddo
c      write(*,*) sumni56,sumni57,sumti44
cqcq
c      call testmod
cqcq
c
c  output : the supernova-model
c
      open(35,file=dir//'slmodel.'//num,status='unknown')
c
      if (i87a.eq.1) then
         write(35,*) 'SN1987A'
      elseif (i93j.eq.1) then
         write(35,*) 'SN1993J'
      endif
c
      write(35,701) tdmod
      write(35,702) mixm,iflphi
      write(35,702) nrmod
      write(35,707) sumni56
      write(35,707) sumni57
      write(35,707) sumti44
c
      do ir=1,nrmod
         iz=izmod(ir)
         write(35,703) ir,iz,rlab(ir),rmod(ir),vrmod(ir),dmmod(ir),
     &        denmod(ir),ameanmod(iz),dmzni56(ir),dmzni57(ir),
     &        dmzti44(ir),(abmod(iz,i),i=1,mie)
      enddo
      ir=nrmod+1
      iz=izmod(nrmod)
      write(35,703) ir,iz,rlab(ir-1),rmod(ir),vrmod(ir)
      write(35,*) '---------------------------------------------------'
      do iz=1,izc
         if (iq(iz).eq.1) then
            volz=0.
            zm=0.
            do ir=1,nrc
               iz0=izmod(ir)
               if (iz.eq.iz0) then
                  zm=zm+dmmod(ir)
                  volz=volz+(4.*pi*(rmod(ir+1)**3-rmod(ir)**3)/3)
               endif
            enddo
            if (mixm.eq.1) then
c  mixed model
               fillq=volz/vtot
            elseif (mixm.eq.0) then
c  non-mixed model
               fillq=fill(iz)
            endif
            write(35,705) iz,zlab(iz),zm,zden(iz),fillq
         endif
      enddo
      write(35,705) izenv,zlabq,zmenv
      close(35)
c      stop
c
 701  format(f6.2)
 702  format(2i2)
 703  format(i5,i3,a12,1pe12.4,25e12.4)
 704  format(1pe12.4,20e12.4)
 705  format(i5,2x,a8,2x,1pe12.4,e12.4,2x,e12.4)
 706  format(i1,6x,e9.3,2f8.0,f6.2,4x,a8,3x,i5,3x,i5)
 707  format(1pe8.2)
c
      return
      end



      subroutine modin
c new 971205 (from run 80.5)
      implicit real*8 (a-h,o-z)
      real*8 mni56,mni57,mni5860,mti44,msun,menv
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      include 'INCLUDE/DATMOL.NOMOL'
      character*8 rlab,zlab,zlabq,qlab,zlabx
      character*4 num
      common/clab/num
      common/csn/i87acl,i87a,i93j,isn
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      common/cphionfl/iflphi
      common/cinput/xein,toldt,tdmax,positron,envfac,menv,
     &     ntd,idep,iextfl,itext
      dimension dmfe(mid)
      dimension vel1z(10),vel2z(10),iq(10)
      dimension zmass(10),zlab(10),fill(10)
      dimension zmassx(10,2),zlabx(10,2),fillx(10,2),zden(10,2)
      dimension iqqx(mid)
      data amu/1.64e-24/,pi/3.14159/,msun/1.989e33/
      include 'INCLUDE/OUTDIR'
c
      do i=1,mid
         vrmod(i)=0.
         rmod(i)=0.
         rlab(i)='        '
         dmmod(i)=0.
         izmod(i)=0
      enddo
c
      do i=1,10
	do j=1,2
	   zden(i,j)=0.d0
           zmassx(i,j)=0.d0
           fillx(i,j)=0.d0
           zlabx(i,j)='        '
	enddo	
      enddo	
c
      if (i87a.eq.1) then
c         open(35,file='INPUT/modin87a.11E1',status='old')
c         open(35,file='INPUT/modin87a.10H_15.1',status='old')
cqcq run 19.4 ; 14E1 envelope
c         open(35,file='INPUT/modin87a.10H.1',status='old')
c         open(35,file='INPUT/modin87a.x1',status='old')
c         open(35,file='INPUT/modin87anew',status='old')
c         open(35,file='INPUT/modin87aiz4',status='old')
cqcq run 19.1 ; dens(H-env) prop to vel**-1
c         open(35,file='INPUT/modin87a.10H_19.1',status='old')
cqcq run 19.2 ; dens(H-env) prop to vel**-2
c         open(35,file='INPUT/modin87a.10H_19.2',status='old')
cqcq run 19.3 ; dens(H-env) prop to vel**-3
c         open(35,file='INPUT/modin87a.10H_19.3',status='old')
cqcq run 19.5 ; 19.2+15.3+extra h-core zone 
c         open(35,file='INPUT/modin87a.10H_19.5',status='old')
cqcq run 19.6 ,19.7 ; 
c         open(35,file='INPUT/modin87a.10H_19.6',status='old')
cqcq run 20 ; 
c         open(35,file='INPUT/modin87a.10H_20',status='old')
cqcq run 20.2 ; run 16.4; run 22.3; run 20.5
c         open(35,file='INPUT/modin87a.10H_20.2',status='old')
cqcq run 22.1
c         open(35,file='INPUT/modin87a.10H_20.2_H',status='old')
cqcq run 21
c         open(35,file='INPUT/modin87a.11E1_21',status='old')
cqcq run 21.2
c         open(35,file='INPUT/modin87a.11E1_21.2',status='old')
cqcq run 21.3
c         open(35,file='INPUT/modin87a.11E1_21.3',status='old')
cqcq run 21.4
c         open(35,file='INPUT/modin87a.11E1_21.4',status='old')
cqcq run 30 ; run 40; run 40.2 ; run 40.1; run 50; run 50.5; run 50.8
cqcq run 60.1; run 60.2; run 60.4; run 60.5; run 60.6; run 60.7
cqcq run 70.1; run 70.4; run 70.5; run 70.6; run 70.7
cqcq run 80.1; run 80.2; run 80.3; run 80.6; run 80.7
cqcq run 99; run 102; run 80.8; run f01
c         open(35,file='INPUT/modin87a.10H_30',status='old')
cqcq last-run 99
         open(35,file='INPUT/modin87a.10H_99',status='old')
cqcq run 80.5 (two fe-he zones; hf (high filling factor)
cqcq                and lf (low filling factor). f(hf)=0.46,M(hf)=0.035
cqcq                f(lf)=0.10,M(lf)=0.035) 
c         open(35,file='INPUT/modin87a.10H_80.5',status='old')
cqcq run 70.9 (2.0*M(57Ni))
c         open(35,file='INPUT/modin87a.10H_70.9',status='old')
cqcq run 70.8 (0.5*M(57Ni))
c         open(35,file='INPUT/modin87a.10H_70.8',status='old')
cqcq run 70.2 (0.5*M(Ti)); run 71.2
c         open(35,file='INPUT/modin87a.10H_70.2',status='old')
cqcq run 70.3 (2*M(Ti)); run 71.3
c         open(35,file='INPUT/modin87a.10H_70.3',status='old')
cqcq run 72.1 (M(Ti)=1.e-5 Msun); run 73.1; run 74.1; run 75.1
c         open(35,file='INPUT/modin87a.10H_72.1',status='old')
cqcq run 72.2 (M(Ti)=1.7e-5 Msun); run 73.2; run 74.2; run 75.2
c         open(35,file='INPUT/modin87a.10H_72.2',status='old')
cqcq run 72.3 (M(Ti)=3.0e-5 Msun); run 73.3; run 74.3; run 75.3
c         open(35,file='INPUT/modin87a.10H_72.3',status='old')
cqcq run 74.4 (M(Ti)=5.0e-5 Msun); run 75.4
c         open(35,file='INPUT/modin87a.10H_74.4',status='old')
cqcq run 74.5 (M(Ti)=1.0e-4 Msun); run 75.5; run 76.5; run 170
cqcq run 173; run 174
c         open(35,file='INPUT/modin87a.10H_30',status='old')
cqcq run 171 (M(Ti)=0.5e-4 Msun)
c         open(35,file='INPUT/modin87a.10H_ti0.5',status='old')
cqcq run 172 (M(Ti)=2.0e-4 Msun)
c         open(35,file='INPUT/modin87a.10H_ti2.0',status='old')
cqcq run 78.1; run 78.2; run 78.3
c         open(35,file='INPUT/modin87a.10H_78.1',status='old')
cqcq run 74.6 (M(Ti)=2.0e-4 Msun); run 75.6
c         open(35,file='INPUT/modin87a.10H_74.6',status='old')
cqcq run 80.4 (filling f(fe-he)=0.10)
c         open(35,file='INPUT/modin87a.10H_80.4',status='old')
c         open(35,file='INPUT/modin87a.10H_60.1',status='old')
c         open(35,file='INPUT/modin87a.10H_60.4',status='old')
cqcq run 60.8 (large filling factor for O, small for Fe)
c         open(35,file='INPUT/modin87a.10H_60.8',status='old')
cqcq run 31; run 31.1; run 31.2 ; run 41; run 41.2; run 41.3; run 41.4
cqcq run 41.5 ; run 41.6; run 41.7; run 61.1
c         open(35,file='INPUT/modin87a.11E1_31',status='old')
      elseif (i93j.eq.1) then
         open(35,file='INPUT/modin93j',status='old')
      endif
c
      read(35,*) tdmod
      read(35,*) izc
      read(35,*) vmin
      read(35,*) vcore
      read(35,*) mni56
      read(35,*) mni57
      read(35,*) mni5860
      read(35,*) mti44
c  read the core regions
      do iz=1,izc
         read(35,706) iz0,zmass(iz),vel1z(iz),vel2z(iz),fill(iz),
     &        zlab(iz),iq(iz)
         if (iq(iz).gt.2) write(50,*) 'iq(iz) out of bound'
         if (iz.ne.iz0) then
            write(50,*) 'Something strange in mod87a !'
            stop
         endif
c
         if (iq(iz).gt.1) then
            do i=1,iq(iz)
               read(35,710) ix,zmassx(iz,i),fillx(iz,i),zlabx(iz,i)
               if (i.ne.ix) write(*,*) i,ix
            enddo
            zmassum=0.d0
            fillsum=0.d0
            do i=1,iq(iz)
               zmassum=zmassum+zmassx(iz,i)
               fillsum=fillsum+fillx(iz,i)
            enddo
            if (zmassum.ne.zmass(iz)) 
     &		write(50,709) 'mass in modin: ',iz,zmass(iz),zmassum 
            if (fillsum.ne.fill(iz)) 
     &		write(50,709) 'fill in modin: ',iz,fill(iz),fillsum 
         elseif (iq(iz).eq.1) then
            zmassx(iz,1)=zmass(iz)
            fillx(iz,1)=fill(iz)
            zlabx(iz,1)=zlab(iz)
         endif   
c
      enddo
      read(35,*)
c
      c1=1.d5*tdmod*8.64d4
      vtot=4.*pi*(c1**3)*(vcore**3-vmin**3)/3
      fsum=0.
      do iz=1,izc
         if (iq(iz).ge.1) fsum=fsum+fill(iz)
      enddo
c
      do iz=1,izc
         do i=1,iq(iz)
            fillx(iz,i)=fillx(iz,i)/fsum
            ameanz=ameanmod(iz)
            zden(iz,i)=(zmassx(iz,i)*msun)/(fillx(iz,i)*vtot*ameanz*amu)
         enddo
      enddo
c
      ir=0
      s=1./3.
      vrmod(1)=vmin
      rmod(1)=c1*vrmod(1)
      do i=1,500
         read(35,708) iz,zm,qlab,iqq
         if(iz.eq.0) goto 91
         if (iqq.ge.1) then
            ir=ir+1
            iqqx(ir)=iqq
            dmmod(ir)=zm
            izmod(ir)=iz
            rlab(ir)=zlabx(iz,iqq)
            denmod(ir)=zden(iz,iqq)
            v1=vrmod(ir)
            volz=(zm*msun)/(zden(iz,iqq)*ameanmod(iz)*amu)
            v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
            r2=c1*v2
            vrmod(ir+1)=v2
            rmod(ir+1)=r2
         endif
      enddo
 91   continue
c
      nrc=ir
c  the envelope region 
      zmenv=0.
      do i=1,100
         read(35,706,end=9,err=9) iz,zmassq,vel1zq,vel2zq,fillq,
     &        zlabq,iqq
         izenv=iz
         if (iqq.eq.1) then
            ir=ir+1
            izmod(ir)=iz
            rlab(ir)=zlabq
            dmmod(ir)=zmassq
            vrmod(ir+1)=vel2zq
            rmod(ir+1)=vrmod(ir+1)*c1
            r1=vel1zq*c1
            r2=vel2zq*c1
            volz=4.*pi*(r2**3-r1**3)/3.
            denmod(ir)=(zmassq*msun)/(volz*ameanmod(iz)*amu)
            zmenv=zmenv+zmassq
         endif
      enddo
 9    continue
      nrmod=ir
c
      close(35)
c
      if (idep.eq.0) then
c  spread out gamma source
c
c  Estimate the masses of ni56, ni57, ni5860 and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
         sumfe=0.
         do ir=1,nrmod
            dmfe(ir)=0.
            iz=izmod(ir)
            abfe=abmod(iz,13)
            amean=ameanmod(iz)
            if (abfe.ge.0.01) then
c         if (iz.le.3) then
c            if (i87a.ne.1) then
c               write(50,*) 'check modin and the distrib of fe'
c            endif
               abfem=(abfe*56)/amean
               dmfe(ir)=dmmod(ir)*abfem
               sumfe=sumfe+dmfe(ir)
            endif
         enddo
c
c  izm is the last shell containing radiactive elements
c
         if (sumfe.le.0.) then
            izm=0
            do ir=1,nrmod
               dmzni56(ir)=0.
               dmzni57(ir)=0.
               dmzni5860(ir)=0.
               dmzti44(ir)=0.
            enddo
         else
            izm=nrmod
            do ir=1,nrmod
               dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
               dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
               dmzni5860(ir)=mni5860*(dmfe(ir)/sumfe)
               dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
               if (dmzni56(ir).gt.0.) izm=ir
               if (dmzni57(ir).gt.0.) izm=ir
               if (dmzti44(ir).gt.0.) izm=ir
            enddo
cqcq run 78.2
c No Ti in the low-density fe-he zones (fe-he hf)            
c            sdm44=0.d0
c            do ir=1,nrmod
c               if (izmod(ir).eq.1.and.iqqx(ir).eq.1) then
c                  sdm44=sdm44+dmzti44(ir)
c                  dmzti44(ir)=0.d0
c               endif
c            enddo
c All Ti in the high-density fe-he zones (fe-he lf) 
c            sumfehf=0.d0
c            do ir=1,nrmod
c               if (izmod(ir).eq.1.and.iqqx(ir).eq.2) then
c                  sumfehf=sumfehf+dmfe(ir)
c               endif
c            enddo
c            do ir=1,nrmod
c               if (izmod(ir).eq.1.and.iqqx(ir).eq.2) then
c                  dmzti44(ir)=dmzti44(ir)+sdm44*dmfe(ir)/sumfehf
c               endif
c            enddo
cqcq run 78.3
c No Ti in the low-density fe-he zones (fe-he hf)            
c            sdm44=0.d0
c            do ir=1,nrmod
c               if (izmod(ir).eq.1.and.iqqx(ir).eq.1) then
c                  sdm44=sdm44+dmzti44(ir)
c                  dmzti44(ir)=0.d0
c               endif
c            enddo
c That Ti instead in the Si-S zones 
c            sumsis=0.d0
c            do ir=1,nrmod
c               if (izmod(ir).eq.2) then
c                  sumsis=sumsis+dmmod(ir)
c               endif
c            enddo
c            do ir=1,nrmod
c               if (izmod(ir).eq.2) then
c                  dmzti44(ir)=dmzti44(ir)+sdm44*dmmod(ir)/sumsis
c               endif
c            enddo
         endif
c
         sumni56=0.
         sumni57=0.
         sumti44=0.
         sumni5860=0.
         do ir=1,nrmod
            sumni56=sumni56+dmzni56(ir)
            sumni57=sumni57+dmzni57(ir)
            sumti44=sumti44+dmzti44(ir)
            sumni5860=sumni5860+dmzni5860(ir)
         enddo
c     write(*,*) sumni56,sumni57,sumni5860,sumti44
      elseif (idep.eq.1) then
c  central gamma source
         izm=0
         do ir=1,nrmod
            dmzni56(ir)=0.
            dmzni57(ir)=0.
            dmzni5860(ir)=0.
            dmzti44(ir)=0.
         enddo
         sumni56=mni56
         sumni57=mni57
         sumti44=mti44
         sumni5860=mni5860
      endif
cqcq
c      call testmod
cqcq
c
c  output : the supernova-model
c
      open(35,file=dir//'slmodel.'//num,status='unknown')
c
      if (i87a.eq.1) then
         write(35,*) 'SN1987A'
      elseif (i93j.eq.1) then
         write(35,*) 'SN1993J'
      endif
c
      write(35,701) tdmod
      write(35,702) mixm,iflphi
      write(35,702) nrmod
      write(35,707) sumni56
      write(35,707) sumni57
      write(35,707) sumti44
c
      do ir=1,nrmod
         iz=izmod(ir)
         write(35,703) ir,iz,rlab(ir),rmod(ir),vrmod(ir),dmmod(ir),
     &        denmod(ir),ameanmod(iz),dmzni56(ir),dmzni57(ir),
     &        dmzni5860(ir),dmzti44(ir),(abmod(iz,i),i=1,mie)
      enddo
      ir=nrmod+1
      iz=izmod(nrmod)
      write(35,703) ir,iz,rlab(ir-1),rmod(ir),vrmod(ir)
      write(35,*) '---------------------------------------------------'
      do iz=1,izc
         do i=1,iq(iz)
            volz=0.
            zm=0.
            do ir=1,nrc
               iz0=izmod(ir)
               if ((iz.eq.iz0).and.(i.eq.iqqx(ir))) then
                  zm=zm+dmmod(ir)
                  volz=volz+(4.*pi*(rmod(ir+1)**3-rmod(ir)**3)/3)
               endif
            enddo
            if (mixm.eq.1) then
c  mixed model
               fillq=volz/vtot
            elseif (mixm.eq.0) then
c  non-mixed model
               fillq=fillx(iz,i)
            endif
            write(35,705) iz,zlabx(iz,i),zm,zden(iz,i),fillq
         enddo
      enddo
      write(35,705) izenv,zlabq,zmenv
      close(35)
c      stop
c
 701  format(f6.2)
 702  format(2i2)
 703  format(i5,i3,a12,1pe12.4,25e12.4)
 704  format(1pe12.4,20e12.4)
 705  format(i5,2x,a8,2x,1pe12.4,e12.4,2x,e12.4)
 706  format(i1,6x,e9.3,2f8.0,e10.2,5x,a8,4x,i1)
 707  format(1pe8.2)
 708  format(i1,6x,e9.3,5x,a8,4x,i1)
 709  format(a15,i4,1pe12.4,1e12.4)
 710  format(i4,e12.3,16x,e10.2,5x,a8)
c
      return
      end


      subroutine modin02
      implicit real*8 (a-h,o-z)
      real*8 mni56,mni57,mni5860,mti44,msun
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      include 'INCLUDE/DATMOL.NOMOL'
      character*8 rlab,zlab,zlabq,qlab
      character*4 num
      common/clab/num
      common/ctpar/tday,dts,iss,iss1,itd
      common/csn/i87acl,i87a,i93j,isn
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      common/cphionfl/iflphi
      dimension dmfe(mid)
      dimension vel1z(10),vel2z(10),iq(10),ns(10)
      dimension zmass(10),zlab(10),fill(10),zden(10)
      data amu/1.64e-24/,pi/3.14159/,msun/1.989e33/
      include 'INCLUDE/OUTDIR'
c
      do i=1,mid
         vrmod(i)=0.
         rmod(i)=0.
         rlab(i)='        '
         dmmod(i)=0.
         izmod(i)=0
      enddo
c
      if (i87a.eq.1) then
         open(35,file='modin87.02',status='old')
      elseif (i93j.eq.1) then
         open(35,file='modin93j',status='old')
      endif
c
      read(35,*) tdmod
      read(35,*) izc
      read(35,*) vmin
      read(35,*) vcore
      read(35,*) mni56
      read(35,*) mni57
      read(35,*) mni5860
      read(35,*) mti44
c  read the core regions
      do iz=1,izc
         read(35,706) iz0,zmass(iz),vel1z(iz),vel2z(iz),fill(iz),
     &        zlab(iz),iq(iz)
         if (iz.ne.iz0) then
            write(50,*) 'Something strange in mod87a !'
            stop
         endif
      enddo
      read(35,*)
c
      c1=1.d5*tdmod*8.64d4
      vtot=4.*pi*(c1**3)*(vcore**3-vmin**3)/3
      fsum=0.
      do iz=1,izc
         if (iq(iz).eq.1) fsum=fsum+fill(iz)
      enddo
c
c iz = 7 ; empty shells
      if (izc.eq.7) then
         fill(7)=1.-(fsum-fill(7))
         fsum=1.
         mno7=4
         no7=0
         sum7=0.
      endif
c
      do iz=1,izc
         zden(iz)=0.
         if (iq(iz).eq.1) then
            fill(iz)=fill(iz)/fsum
            if (iz.eq.7) then
               zden(iz)=0.
            else
               ameanz=ameanmod(iz)
               zden(iz)=(zmass(iz)*msun)/(fill(iz)*vtot*ameanz*amu)
            endif
         endif
      enddo
c
      ir=0
      s=1./3.
      vrmod(1)=vmin
      rmod(1)=c1*vrmod(1)
      do i=1,500
         read(35,708) iz,zm,qlab,iqq
         if(iz.eq.0) goto 91
         if (iqq.eq.1) then
            ir=ir+1
            dmmod(ir)=zm
            izmod(ir)=iz
            rlab(ir)=zlab(iz)
            denmod(ir)=zden(iz)
            v1=vrmod(ir)
            if (iz.eq.7) then
               no7=no7+1
               if (no7.eq.mno7) then
                  volz=vtot*fill(7)-sum7
                  v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
               else
                  dv=vrmod(ir)-vrmod(ir-1)
                  v2=vrmod(ir)+dv
                  volz=(4.*pi/3.)*(c1**3)*(v2**3-v1**3)
                  do while ((sum7+volz).ge.fill(7)*vtot)
                     dv=dv*0.5
                     v2=vrmod(ir)+dv
                     volz=(4.*pi/3.)*(c1**3)*(v2**3-v1**3)
                  enddo
               endif
               sum7=sum7+volz
            else
               volz=(zm*msun)/(zden(iz)*ameanmod(iz)*amu)
               v2=((3.*volz/(4.*pi*(c1**3)))+v1**3)**s
            endif
            r2=c1*v2
            vrmod(ir+1)=v2
            rmod(ir+1)=r2
         endif
      enddo
 91   continue
c
      nrc=ir
c  the envelope region 
      zmenv=0.
      do i=1,100
         read(35,706,end=9,err=9) iz,zmassq,vel1zq,vel2zq,fillq,
     &        zlabq,iqq
         izenv=iz
         if (iqq.eq.1) then
            ir=ir+1
            izmod(ir)=iz
            rlab(ir)=zlabq
            dmmod(ir)=zmassq
            vrmod(ir+1)=vel2zq
            rmod(ir+1)=vrmod(ir+1)*c1
            r1=vel1zq*c1
            r2=vel2zq*c1
            volz=4.*pi*(r2**3-r1**3)/3.
            denmod(ir)=(zmassq*msun)/(volz*ameanmod(iz)*amu)
            zmenv=zmenv+zmassq
         endif
      enddo
 9    continue
      nrmod=ir
c
      close(35)
c
c  Estimate the masses of ni56, ni57, ni5860 and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=ameanmod(iz)
         if (abfe.ge.0.01) then
c         if (iz.le.3) then
c            if (i87a.ne.1) then
c               write(50,*) 'check modin and the distrib of fe'
c            endif
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
c  izm is the last shell containing radiactive elements
c
      if (sumfe.le.0.) then
         izm=0
         do ir=1,nrmod
            dmzni56(ir)=0.
            dmzni57(ir)=0.
            dmzni5860(ir)=0.
            dmzti44(ir)=0.
         enddo
      else
         izm=nrmod
         do ir=1,nrmod
            dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
            dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
            dmzni5860(ir)=mni5860*(dmfe(ir)/sumfe)
            dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
            if (dmzni56(ir).gt.0.) izm=ir
            if (dmzni57(ir).gt.0.) izm=ir
            if (dmzti44(ir).gt.0.) izm=ir
         enddo
      endif
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      sumni5860=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
         sumni5860=sumni5860+dmzni5860(ir)
      enddo
c      write(*,*) sumni56,sumni57,sumni5860,sumti44
cqcq
c      call testmod
cqcq
c
c  output : the supernova-model
c
      open(35,file=dir//'slmodel.'//num,status='unknown')
c
      if (i87a.eq.1) then
         write(35,*) 'SN1987A'
      elseif (i93j.eq.1) then
         write(35,*) 'SN1993J'
      endif
c
      write(35,701) tdmod
      write(35,702) mixm,iflphi
      write(35,702) nrmod
      write(35,707) sumni56
      write(35,707) sumni57
      write(35,707) sumti44
c
      do ir=1,nrmod
         iz=izmod(ir)
         write(35,703) ir,iz,rlab(ir),rmod(ir),vrmod(ir),dmmod(ir),
     &        denmod(ir),ameanmod(iz),dmzni56(ir),dmzni57(ir),
     &        dmzni5860(ir),dmzti44(ir),(abmod(iz,i),i=1,mie)
      enddo
      ir=nrmod+1
      iz=izmod(nrmod)
      write(35,703) ir,iz,rlab(ir-1),rmod(ir),vrmod(ir)
      write(35,*) '---------------------------------------------------'
      do iz=1,izc
         if (iq(iz).eq.1) then
            volz=0.
            zm=0.
            do ir=1,nrc
               iz0=izmod(ir)
               if (iz.eq.iz0) then
                  zm=zm+dmmod(ir)
                  volz=volz+(4.*pi*(rmod(ir+1)**3-rmod(ir)**3)/3)
               endif
            enddo
            if (mixm.eq.1) then
c  mixed model
               fillq=volz/vtot
            elseif (mixm.eq.0) then
c  non-mixed model
               fillq=fill(iz)
            endif
            write(35,705) iz,zlab(iz),zm,zden(iz),fillq
         endif
      enddo
      write(35,705) izenv,zlabq,zmenv
      close(35)
c      stop
c
 701  format(f6.2)
 702  format(2i2)
 703  format(i5,i3,a12,1pe12.4,25e12.4)
 704  format(1pe12.4,20e12.4)
 705  format(i5,2x,a8,2x,1pe12.4,e12.4,2x,e12.4)
 706  format(i1,6x,e9.3,2f8.0,e10.2,5x,a8,4x,i1)
 707  format(1pe8.2)
 708  format(i1,6x,e9.3,5x,a8,4x,i1)
c
      return
      end


      subroutine rad93j
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      character*8 rlab
      real*8 mni56,mni57,mni5860,mti44
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      dimension dmfe(mid)
c
c  non-mixed case for 93j
c  (20 zones) for the core region (nrc)
c  (5  zones) for the envelope region (nre)
c
c  homologous expansion is assumed after t=80 days
c  vrmod = velocity in km/s
c  rmod  = radius in cm for the corresponding velocity at
c          t=80 days.
c
      ir=0
      goto 88
 88   continue
c  core-region
c  he-fe iz=1 
      iz=1
c
      ir=ir+1
      vrmod(ir)=990.
      rmod(ir)=1.046d15
      rlab(ir)=' he - fe'
      izmod(ir)=iz
      nrtab(ir)=1
      dmmod(ir)=6.2622d-3
c
      ir=ir+1
      vrmod(ir)=1600.
      rmod(ir)=1.225d15
      rlab(ir)=' he - fe'
      izmod(ir)=iz
      nrtab(ir)=2
      dmmod(ir)=5.9560d-3
c
      ir=ir+1
      vrmod(ir)=1800.
      rmod(ir)=1.286d15
      rlab(ir)=' he - fe'
      izmod(ir)=iz
      nrtab(ir)=3
      dmmod(ir)=1.9969d-2
c
c  fe-he iz=2 
      iz=2
c
      ir=ir+1
      vrmod(ir)=1950.
      rmod(ir)=1.359d15
      rlab(ir)=' fe - he'
      izmod(ir)=iz
      nrtab(ir)=4
      dmmod(ir)=0.0318
c
      ir=ir+1
      vrmod(ir)=2100.
      rmod(ir)=1.459d15
      rlab(ir)=' fe - he'
      izmod(ir)=iz
      nrtab(ir)=5
      dmmod(ir)=0.0806
cxxxx
c
      ir=ir+1
      vrmod(ir)=2250.
      rmod(ir)=1.557d15
      rlab(ir)=' fe - he'
      izmod(ir)=iz
      nrtab(ir)=6
      dmmod(ir)=0.0562
c  si-s iz=3 
      iz=3
c
      ir=ir+1
      vrmod(ir)=2340.
      rmod(ir)=1.620d15
      rlab(ir)=' si - s '
      izmod(ir)=iz
      nrtab(ir)=7
      dmmod(ir)=0.0458
c
      ir=ir+1
      vrmod(ir)=2400.
      rmod(ir)=1.662d15
      rlab(ir)=' si - s '
      izmod(ir)=iz
      nrtab(ir)=8
      dmmod(ir)=0.1084
c  o-mg iz=4 
      iz=4
c
      ir=ir+1
      vrmod(ir)=2540.
      rmod(ir)=1.764d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=9
      dmmod(ir)=0.1284
c
      ir=ir+1
      vrmod(ir)=2700.
      rmod(ir)=1.871d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=10
      dmmod(ir)=0.1217
c
      ir=ir+1
      vrmod(ir)=2850.
      rmod(ir)=1.975d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=11
      dmmod(ir)=0.0965
c
      ir=ir+1
      vrmod(ir)=3000.
      rmod(ir)=2.086d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=12
      dmmod(ir)=0.0726
c  o-c iz=5 
      iz=5
c
      ir=ir+1
      vrmod(ir)=3200.
      rmod(ir)=2.209d15
      rlab(ir)=' o - c  '
      izmod(ir)=iz
      nrtab(ir)=13
      dmmod(ir)=0.0473
c
      ir=ir+1
      vrmod(ir)=3300.
      rmod(ir)=2.286d15
      rlab(ir)=' o - c  '
      izmod(ir)=iz
      nrtab(ir)=14
      dmmod(ir)=0.0335
c  he-c iz=6 
      iz=6
c
      ir=ir+1
      vrmod(ir)=3400.
      rmod(ir)=2.359d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=15
      dmmod(ir)=0.2199
c
      ir=ir+1
      vrmod(ir)=4000.
      rmod(ir)=2.785d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=16
      dmmod(ir)=0.2266
c
      ir=ir+1
      vrmod(ir)=4500.
      rmod(ir)=3.125d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=17
      dmmod(ir)=0.2794
c
      ir=ir+1
      vrmod(ir)=5000.
      rmod(ir)=3.484d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=18
      dmmod(ir)=0.2876
c
      ir=ir+1
      vrmod(ir)=5500.
      rmod(ir)=3.819d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=19
      dmmod(ir)=0.2963
c
      ir=ir+1
      vrmod(ir)=6000.
      rmod(ir)=4.171d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=20
      dmmod(ir)=0.2086
c  he-n  iz=7 
      iz=7
c
      ir=ir+1
      vrmod(ir)=6420.
      rmod(ir)=4.449d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=21
      dmmod(ir)=0.1132
c
      ir=ir+1
      vrmod(ir)=6700.
      rmod(ir)=4.637d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=22
      dmmod(ir)=0.1040
c
      ir=ir+1
      vrmod(ir)=7000.
      rmod(ir)=4.844d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=23
      dmmod(ir)=0.0702
c  envelope-region iz=8 
      iz=8
c
      ir=ir+1
      vrmod(ir)=7250.
      rmod(ir)=5.017d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=24
      dmmod(ir)=0.1873
c
cqcq>
c      ir=ir+1
c      vrmod(ir)=7750
c      rmod(ir)=5.363d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
      ir=ir+1
      vrmod(ir)=8300.
      rmod(ir)=5.744d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=25
      dmmod(ir)=0.1916
c
cqcq>
c      ir=ir+1
c      vrmod(ir)=8800.
c      rmod(ir)=6.088d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
      ir=ir+1
      vrmod(ir)=9300.
      rmod(ir)=6.432d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=26
      dmmod(ir)=0.0564
c
      ir=ir+1
      vrmod(ir)=10000.
      rmod(ir)=6.913d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=27
      dmmod(ir)=0.0176
c
cqcq >
c      ir=ir+1
c      vrmod(ir)=11000.
c      rmod(ir)=7.605d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq <
c
      ir=ir+1
      vrmod(ir)=12000.
      rmod(ir)=8.298d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=28
      dmmod(ir)=0.0145
cqcq >
c      ir=ir+1
c      vrmod(ir)=13000.
c      rmod(ir)=8.992d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=14000.
c      rmod(ir)=9.686d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq <
c
      ir=ir+1
      vrmod(ir)=15000.
      rmod(ir)=1.038d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=29
      dmmod(ir)=0.0269
cqcq>
c      ir=ir+1
c      vrmod(ir)=16000.
c      rmod(ir)=1.107d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=17000.
c      rmod(ir)=1.177d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=18000.
c      rmod(ir)=1.246d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=19000.
c      rmod(ir)=1.316d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
c
      ir=ir+1
      vrmod(ir)=19900.
      rmod(ir)=1.378d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      dmmod(ir)=0.d0
c
      goto 89
 89   continue
      nrmod=ir-1
c
c  Estimate the masses of ni56, ni57, and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=0.
         do ie=1,mie
            amean=amean+abmod(iz,ie)*aw(ie)
         enddo
         if (abfe.ge.0.01) then
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
      izm=nrmod
      do ir=1,nrmod
         dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
         dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
         dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
         if (dmzni56(ir).gt.0.) izm=ir
         if (dmzni57(ir).gt.0.) izm=ir
         if (dmzti44(ir).gt.0.) izm=ir
      enddo
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
      enddo
c      write(*,*) sumni56,sumni57,sumti44
c
      return
      end


      subroutine rad93jcut
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      character*8 rlab
      real*8 mni56,mni57,mni5860,mti44
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      dimension dmfe(mid)
c
c  same as rad93j but the inner zones are cut away here so that 
c  M(Fe) = M(Ni) = 0.07 Msun
c
c  non-mixed case for 93j
c  (20 zones) for the core region (nrc)
c  (5  zones) for the envelope region (nre)
c
c  homologous expansion is assumed after t=80 days
c  vrmod = velocity in km/s
c  rmod  = radius in cm for the corresponding velocity at
c          t=80 days.
c
      ir=0
      goto 88
 88   continue
c  core-region
c  he-fe iz=1 
c      iz=1
c
c      ir=ir+1
c      vrmod(ir)=990.
c      rmod(ir)=1.046d15
c      rlab(ir)=' he - fe'
c      izmod(ir)=iz
c      nrtab(ir)=1
c      dmmod(ir)=6.2622d-3
c
c      ir=ir+1
c      vrmod(ir)=1600.
c      rmod(ir)=1.225d15
c      rlab(ir)=' he - fe'
c      izmod(ir)=iz
c      nrtab(ir)=2
c      dmmod(ir)=5.9560d-3
c
c      ir=ir+1
c      vrmod(ir)=1800.
c      rmod(ir)=1.286d15
c      rlab(ir)=' he - fe'
c      izmod(ir)=iz
c      nrtab(ir)=3
c      dmmod(ir)=1.9969d-2
c
c  fe-he iz=2 
      iz=2
c
c      ir=ir+1
c      vrmod(ir)=1950.
c      rmod(ir)=1.359d15
c      rlab(ir)=' fe - he'
c      izmod(ir)=iz
c      nrtab(ir)=4
c      dmmod(ir)=0.0318
c
c      ir=ir+1
c      vrmod(ir)=2100.
c      rmod(ir)=1.459d15
c      rlab(ir)=' fe - he'
c      izmod(ir)=iz
c      nrtab(ir)=5
c      dmmod(ir)=0.0806
cxxxx
      ir=ir+1
      vrmod(ir)=2205.
      rmod(ir)=1.524d15
      rlab(ir)=' fe - he'
      izmod(ir)=iz
      nrtab(ir)=5
      dmmod(ir)=0.0254
cxxxx
c
      ir=ir+1
      vrmod(ir)=2250.
      rmod(ir)=1.557d15
      rlab(ir)=' fe - he'
      izmod(ir)=iz
      nrtab(ir)=6
      dmmod(ir)=0.0562
c  si-s iz=3 
      iz=3
c
      ir=ir+1
      vrmod(ir)=2340.
      rmod(ir)=1.620d15
      rlab(ir)=' si - s '
      izmod(ir)=iz
      nrtab(ir)=7
      dmmod(ir)=0.0458
c
      ir=ir+1
      vrmod(ir)=2400.
      rmod(ir)=1.662d15
      rlab(ir)=' si - s '
      izmod(ir)=iz
      nrtab(ir)=8
      dmmod(ir)=0.1084
c  o-mg iz=4 
      iz=4
c
      ir=ir+1
      vrmod(ir)=2540.
      rmod(ir)=1.764d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=9
      dmmod(ir)=0.1284
c
      ir=ir+1
      vrmod(ir)=2700.
      rmod(ir)=1.871d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=10
      dmmod(ir)=0.1217
c
      ir=ir+1
      vrmod(ir)=2850.
      rmod(ir)=1.975d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=11
      dmmod(ir)=0.0965
c
      ir=ir+1
      vrmod(ir)=3000.
      rmod(ir)=2.086d15
      rlab(ir)=' o - mg '
      izmod(ir)=iz
      nrtab(ir)=12
      dmmod(ir)=0.0726
c  o-c iz=5 
      iz=5
c
      ir=ir+1
      vrmod(ir)=3200.
      rmod(ir)=2.209d15
      rlab(ir)=' o - c  '
      izmod(ir)=iz
      nrtab(ir)=13
      dmmod(ir)=0.0473
c
      ir=ir+1
      vrmod(ir)=3300.
      rmod(ir)=2.286d15
      rlab(ir)=' o - c  '
      izmod(ir)=iz
      nrtab(ir)=14
      dmmod(ir)=0.0335
c  he-c iz=6 
      iz=6
c
      ir=ir+1
      vrmod(ir)=3400.
      rmod(ir)=2.359d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=15
      dmmod(ir)=0.2199
c
      ir=ir+1
      vrmod(ir)=4000.
      rmod(ir)=2.785d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=16
      dmmod(ir)=0.2266
c
      ir=ir+1
      vrmod(ir)=4500.
      rmod(ir)=3.125d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=17
      dmmod(ir)=0.2794
c
      ir=ir+1
      vrmod(ir)=5000.
      rmod(ir)=3.484d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=18
      dmmod(ir)=0.2876
c
      ir=ir+1
      vrmod(ir)=5500.
      rmod(ir)=3.819d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=19
      dmmod(ir)=0.2963
c
      ir=ir+1
      vrmod(ir)=6000.
      rmod(ir)=4.171d15
      rlab(ir)=' he - c '
      izmod(ir)=iz
      nrtab(ir)=20
      dmmod(ir)=0.2086
c  he-n  iz=7 
      iz=7
c
      ir=ir+1
      vrmod(ir)=6420.
      rmod(ir)=4.449d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=21
      dmmod(ir)=0.1132
c
      ir=ir+1
      vrmod(ir)=6700.
      rmod(ir)=4.637d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=22
      dmmod(ir)=0.1040
c
      ir=ir+1
      vrmod(ir)=7000.
      rmod(ir)=4.844d15
      rlab(ir)=' he - n '
      izmod(ir)=iz
      nrtab(ir)=23
      dmmod(ir)=0.0702
c  envelope-region iz=8 
      iz=8
c
      ir=ir+1
      vrmod(ir)=7250.
      rmod(ir)=5.017d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=24
      dmmod(ir)=0.1873
c
cqcq>
c      ir=ir+1
c      vrmod(ir)=7750
c      rmod(ir)=5.363d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
      ir=ir+1
      vrmod(ir)=8300.
      rmod(ir)=5.744d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=25
      dmmod(ir)=0.1916
c
cqcq>
c      ir=ir+1
c      vrmod(ir)=8800.
c      rmod(ir)=6.088d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
      ir=ir+1
      vrmod(ir)=9300.
      rmod(ir)=6.432d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=26
      dmmod(ir)=0.0564
c
      ir=ir+1
      vrmod(ir)=10000.
      rmod(ir)=6.913d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=27
      dmmod(ir)=0.0176
c
cqcq >
c      ir=ir+1
c      vrmod(ir)=11000.
c      rmod(ir)=7.605d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq <
c
      ir=ir+1
      vrmod(ir)=12000.
      rmod(ir)=8.298d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=28
      dmmod(ir)=0.0145
cqcq >
c      ir=ir+1
c      vrmod(ir)=13000.
c      rmod(ir)=8.992d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=14000.
c      rmod(ir)=9.686d15
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq <
c
      ir=ir+1
      vrmod(ir)=15000.
      rmod(ir)=1.038d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=29
      dmmod(ir)=0.0269
cqcq>
c      ir=ir+1
c      vrmod(ir)=16000.
c      rmod(ir)=1.107d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=17000.
c      rmod(ir)=1.177d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=18000.
c      rmod(ir)=1.246d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
c
c      ir=ir+1
c      vrmod(ir)=19000.
c      rmod(ir)=1.316d16
c      rlab(ir)=' h-env  '
c      izmod(ir)=iz
cqcq<
c
      ir=ir+1
      vrmod(ir)=19900.
      rmod(ir)=1.378d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      dmmod(ir)=0.d0
      goto 89
 89   continue
c
      nrmod=ir-1
c
c  Estimate the masses of ni56, ni57, and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=0.
         do ie=1,mie
            amean=amean+abmod(iz,ie)*aw(ie)
         enddo
         if (abfe.ge.0.01) then
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
      izm=nrmod
      do ir=1,nrmod
         dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
         dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
         dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
         if (dmzni56(ir).gt.0.) izm=ir
         if (dmzni57(ir).gt.0.) izm=ir
         if (dmzti44(ir).gt.0.) izm=ir
      enddo
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
      enddo
c      write(*,*) sumni56,sumni57,sumti44
c
      return
      end


      subroutine radm93
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      character*8 rlab,zlab
      real*8 mni56,mni57,mni5860,mti44
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      dimension zmass(10),dr3z(10),zlab(10),dmfe(mid)
      dimension zden(10)
      data pi/3.14159/
c
c  mixed case for 93j
c
c  homologous expansion is assumed after t=80 days
c  vrmod = velocity in km/s
c  rmod  = radius in cm for the corresponding velocity at
c          t=80 days.
c  nsh   = number of shells for each composition-zone, iz 
c  izmix = the highest iz which is mixed 
c  zmass = mass (in solar-masses) for the different zones
c          from Nomotos model
c  zden  = mean-density (g/cm**3) for each zone at t=80 days
c  vel1  = the innermost velocity in km/s, of the mixed region
c  vel2  = the outermost velocity in km/s, of the mixed region
c
      ir=0
c
      nsh=5
      izmix=7
c      nsh=1
c      izmix=1
      vel1=990.
      vel2=7250.
c
c  he - fe
      iz=1
      zmass(iz)=3.65d-2
      zden(iz)=1.20d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' he - fe'
c  fe - he
      iz=2
      zmass(iz)=1.71d-1
      zden(iz)=4.75d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' fe - he'
c  si - s
      iz=3
      zmass(iz)=1.69d-1
      zden(iz)=5.91d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' si - s '
c  o - mg
      iz=4
      zmass(iz)=2.95d-1
      zden(iz)=3.24d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' o - mg '
c  o - c
      iz=5
      zmass(iz)=8.41d-2
      zden(iz)=1.53d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' o - c  '
c  he - c
      iz=6
      zmass(iz)=1.51
      zden(iz)=9.61d-15
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' he - c '
c  he - n
      iz=7
      zmass(iz)=2.91d-1
      zden(iz)=3.53d-15
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' he - n '
c
      ir=1
      vrmod(ir)=vel1
      rmod(ir)=(5.0289-(7267.2-vrmod(ir))/1.45e3)*1.e15
      iz=1
      izmod(ir)=iz
      rlab(ir)=zlab(iz)
      dmmod(ir)=zmass(izmod(ir))/dble(nsh)
      irmax=nsh*izmix
      nrtab(1)=1
      s=1/3.
      do ir=2,irmax
         iz=iz+1
         if (iz.gt.izmix) iz=1
         izmod(ir)=iz
         rlab(ir)=zlab(iz)
         dmmod(ir)=zmass(izmod(ir))/dble(nsh)
cqcq
cqcq         rmod(ir)=(rmod(ir-1)**3+dr3z(iz))**s
         rmod(ir)=(rmod(ir-1)**3+dr3z(izmod(ir-1)))**s
         vrmod(ir)=7267.2-1.45e3*(5.0289-rmod(ir)*1.e-15)
         nrtab(ir)=ir
      enddo
cqcq      rmod(irmax+1)=(rmod(irmax)**3+dr3z(iz))**s
      rmod(irmax+1)=(rmod(irmax)**3+dr3z(izmod(irmax)))**s
      vrmod(irmax+1)=7267.2-1.45e3*(5.0289-rmod(irmax+1)*1.e-15)
c  envelope-region iz=8 
c      goto 89
      iz=8
c
c      ir=ir+1
      ir=irmax+1
      vrmod(ir)=7250.
      rmod(ir)=5.017d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.1873
c
      ir=ir+1
      vrmod(ir)=8300.
      rmod(ir)=5.744d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.1916
c
      ir=ir+1
      vrmod(ir)=9300.
      rmod(ir)=6.432d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0564
c
      ir=ir+1
      vrmod(ir)=10000.
      rmod(ir)=6.913d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0176
c
      ir=ir+1
      vrmod(ir)=12000.
      rmod(ir)=8.298d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0145
c
      ir=ir+1
      vrmod(ir)=15000.
      rmod(ir)=1.038d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0269
c
      ir=ir+1
      vrmod(ir)=19900.
      rmod(ir)=1.378d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.d0
c
 89   continue
      nrmod=ir-1
c
c  Estimate the masses of ni56, ni57, and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=0.
         do ie=1,mie
            amean=amean+abmod(iz,ie)*aw(ie)
         enddo
         if (abfe.ge.0.01) then
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
      izm=nrmod
      do ir=1,nrmod
         dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
         dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
         dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
         if (dmzni56(ir).gt.0.) izm=ir
         if (dmzni57(ir).gt.0.) izm=ir
         if (dmzti44(ir).gt.0.) izm=ir
      enddo
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
      enddo
      write(*,*) sumni56,sumni57,sumti44
c
      return
      end


      subroutine radm93cut
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      character*8 rlab,zlab
      real*8 mni56,mni57,mni5860,mti44
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      dimension zmass(10),dr3z(10),zlab(10),dmfe(mid)
      dimension zden(10)
      data pi/3.14159/
c
c  mixed case for 93j
c
c  homologous expansion is assumed after t=80 days
c  vrmod = velocity in km/s
c  rmod  = radius in cm for the corresponding velocity at
c          t=80 days.
c  nsh   = number of shells for each composition-zone, iz 
c  izmix = the highest iz which is mixed 
c  zmass = mass (in solar-masses) for the different zones
c          from Nomotos model
c  zden  = mean-density (g/cm**3) for each zone at t=80 days
c  vel1  = the innermost velocity in km/s, of the mixed region
c  vel2  = the outermost velocity in km/s, of the mixed region
c
      ir=0
c
      nsh=5
      izmix=7
c      nsh=1
c      izmix=1
      vel1=990.
      vel2=7250.
c
c  he - fe
c      iz=1
c      zmass(iz)=3.65d-2
c      zden(iz)=1.20d-14
c      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
c      zlab(iz)=' he - fe'
c  fe - he
      iz=2
c      zmass(iz)=1.71d-1
      zmass(iz)=8.16d-2
      zden(iz)=4.75d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' fe - he'
c  si - s
      iz=3
c      zmass(iz)=1.69d-1
      zmass(iz)=1.542d-1
      zden(iz)=5.91d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' si - s '
c  o - mg
      iz=4
c      zmass(iz)=2.95d-1
      zmass(iz)=4.192d-1
      zden(iz)=3.24d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' o - mg '
c  o - c
      iz=5
c      zmass(iz)=8.41d-2
      zmass(iz)=8.08d-2
      zden(iz)=1.53d-14
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' o - c  '
c  he - c
      iz=6
c      zmass(iz)=1.51
      zmass(iz)=1.5184
      zden(iz)=9.61d-15
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' he - c '
c  he - n
      iz=7
c      zmass(iz)=2.91d-1
      zmass(iz)=2.874d-1
      zden(iz)=3.53d-15
      dr3z(iz)=3.*zmass(iz)*1.989e33/(4.*pi*dble(nsh)*zden(iz))
      zlab(iz)=' he - n '
c
      ir=1
      vrmod(ir)=vel1
      rmod(ir)=(5.0289-(7267.2-vrmod(ir))/1.45e3)*1.e15
c      iz=1
      iz=2
      izmod(ir)=iz
      rlab(ir)=zlab(iz)
      dmmod(ir)=zmass(izmod(ir))/dble(nsh)
c      irmax=nsh*izmix
      irmax=nsh*(izmix-1)
      nrtab(1)=1
      s=1/3.
      do ir=2,irmax
         iz=iz+1
c         if (iz.gt.izmix) iz=1
         if (iz.gt.izmix) iz=2
         izmod(ir)=iz
         rlab(ir)=zlab(iz)
         dmmod(ir)=zmass(izmod(ir))/dble(nsh)
cqcq
cqcq         rmod(ir)=(rmod(ir-1)**3+dr3z(iz))**s
         rmod(ir)=(rmod(ir-1)**3+dr3z(izmod(ir-1)))**s
         vrmod(ir)=7267.2-1.45e3*(5.0289-rmod(ir)*1.e-15)
         nrtab(ir)=ir
      enddo
cqcq      rmod(irmax+1)=(rmod(irmax)**3+dr3z(iz))**s
      rmod(irmax+1)=(rmod(irmax)**3+dr3z(izmod(irmax)))**s
      vrmod(irmax+1)=7267.2-1.45e3*(5.0289-rmod(irmax+1)*1.e-15)
c  envelope-region iz=8 
c      goto 89
      iz=8
c
c      ir=ir+1
      ir=irmax+1
      vrmod(ir)=7250.
      rmod(ir)=5.017d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.1873
c
      ir=ir+1
      vrmod(ir)=8300.
      rmod(ir)=5.744d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.1916
c
      ir=ir+1
      vrmod(ir)=9300.
      rmod(ir)=6.432d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0564
c
      ir=ir+1
      vrmod(ir)=10000.
      rmod(ir)=6.913d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0176
c
      ir=ir+1
      vrmod(ir)=12000.
      rmod(ir)=8.298d15
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0145
c
      ir=ir+1
      vrmod(ir)=15000.
      rmod(ir)=1.038d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.0269
c
      ir=ir+1
      vrmod(ir)=19900.
      rmod(ir)=1.378d16
      rlab(ir)=' h-env  '
      izmod(ir)=iz
      nrtab(ir)=ir
      dmmod(ir)=0.d0
c
 89   continue
      nrmod=ir-1
c
c  Estimate the masses of ni56, ni57, and ti44 for the
c  different shells.
c  Assume that these radioactive elements follow the iron abundance.
c
      sumfe=0.
      do ir=1,nrmod
         dmfe(ir)=0.
         iz=izmod(ir)
         abfe=abmod(iz,13)
         amean=0.
         do ie=1,mie
            amean=amean+abmod(iz,ie)*aw(ie)
         enddo
         if (abfe.ge.0.01) then
            abfem=(abfe*56)/amean
            dmfe(ir)=dmmod(ir)*abfem
            sumfe=sumfe+dmfe(ir)
         endif
      enddo
c
      izm=nrmod
      do ir=1,nrmod
         dmzni56(ir)=mni56*(dmfe(ir)/sumfe)
         dmzni57(ir)=mni57*(dmfe(ir)/sumfe)
         dmzti44(ir)=mti44*(dmfe(ir)/sumfe)
         if (dmzni56(ir).gt.0.) izm=ir
         if (dmzni57(ir).gt.0.) izm=ir
         if (dmzti44(ir).gt.0.) izm=ir
      enddo
c
      sumni56=0.
      sumni57=0.
      sumti44=0.
      do ir=1,nrmod
         sumni56=sumni56+dmzni56(ir)
         sumni57=sumni57+dmzni57(ir)
         sumti44=sumti44+dmzti44(ir)
      enddo
      write(*,*) sumni56,sumni57,sumti44
c
      return
      end




      subroutine testmod
      implicit real*8 (a-h,o-z)
      real*8 mni56,mni57,mni5860,mti44,msun
      include 'INCLUDE/PARAM.IOR'
      include 'INCLUDE/DATIE'
      include 'INCLUDE/DATMOL.NOMOL'
      real*8 menv
      character*8 rlab
      common/cmod/abmod(10,mie),vrmod(mid),rmod(mid),rlab(mid),
     &     dmmod(mid),ameanmod(10),denmod(mid),tdmod,
     &     nrtab(mid),izmod(mid),nrmod,mixm
      common/cmass/mni56,mni57,mni5860,mti44,fracenv,
     &     dmzni56(mid),dmzni57(mid),dmzni5860(mid),
     &     dmzti44(mid),izm
      common/cinput/xein,toldt,tdmax,positron,envfac,menv,
     &     ntd,idep,iextfl,itext
      dimension zden(10)
      data amu/1.64e-24/,pi/3.14159/,msun/1.989e33/
c
c---------------------------
c  only three he shells
c      nrmod=3
c      rmod(1)=3.456e15
c      rmod(2)=3.867e15
c      rmod(3)=4.203e15
c      rmod(4)=4.496e15
c      vrmod(1)=1000.
c      vrmod(2)=1119.
c      vrmod(3)=1216.
c      vrmod(4)=1301.
c      izmod(1)=5
c      izmod(2)=5
c      izmod(3)=5
c      rlab(1)=' he     '
c      rlab(2)=' he     '
c      rlab(3)=' he     '
c      dmmod(1)=0.6667
c      dmmod(2)=0.6667
c      dmmod(3)=0.6667
c      denmod(1)=2.76e9
c      denmod(2)=2.76e9
c      denmod(3)=2.76e9
c      zden(5)=2.76e9
c      ameanmod(5)=4.24
c      dmzni56(1)=0.
c      dmzni56(2)=0.
c      dmzni56(3)=0.
c      dmzni57(1)=0.
c      dmzni57(2)=0.
c      dmzni57(3)=0.
c      dmzti44(1)=0.
c      dmzti44(2)=0.
c      dmzti44(3)=0.
c---------------------------
c  three o-si-s shells
c      nrmod=3
c      v1=1000.
c      fill=(0.24/3.)*2.
c      vm=2000
c      fivm3=fill*(vm**3)
c      dm=0.6667*2.
c      zden(3)=4.15e8
c      ameanmod(3)=17.6
c      vrmod(1)=v1
c      rmod(1)=vrmod(1)*1.e5*400.*24.*3600.
c      do i=1,3
c        vrmod(i+1)=(vrmod(i)**3.+fivm3)**(1./3.)
c        rmod(i+1)=vrmod(i+1)*1.e5*400.*24.*3600.
c         izmod(i)=3
c         rlab(i)=' o-si-s '
c         dmmod(i)=dm
c         denmod(i)=zden(3)
c         dmzni56(i)=0.
c         dmzni57(i)=0.
c         dmzti44(i)=0.
c      enddo
c---------------------------
c  three o-si-s shells
      nrmod=1
c      nrmod=5
      vrmod(1)=494.71
      vrmod(2)=804.34
c      vrmod(3)=1497.2
c      vrmod(4)=1586.9
c      vrmod(5)=1872.0
c      vrmod(6)=1931.0
c      do i=1,6
      do i=1,2
         rmod(i)=vrmod(i)*1.e5*400.*24.*3600.
      enddo
      izmod(1)=3
c      izmod(3)=3
c      izmod(5)=3
      rlab(1)=' o-si-s '
c      rlab(3)=' o-si-s '
c      rlab(5)=' o-si-s '
      dmmod(1)=1.0000
c      dmmod(3)=0.6667
c      dmmod(5)=0.6667
c      dmmod(2)=0.
c      dmmod(4)=0.
      denmod(1)=9.9777e8
c      denmod(3)=4.15e8
c      denmod(5)=4.15e8
c      denmod(2)=0.
c      denmod(4)=0.
      zden(3)=4.15e8
      ameanmod(3)=17.6
      dmzni56(1)=0.
c      dmzni56(2)=0.
c      dmzni56(3)=0.
c      dmzni56(4)=0.
c      dmzni56(5)=0.
      dmzni57(1)=0.
c      dmzni57(2)=0.
c      dmzni57(3)=0.
c      dmzni57(4)=0.
c      dmzni57(5)=0.
      dmzti44(1)=0.
c      dmzti44(2)=0.
c      dmzti44(3)=0.
c      dmzti44(4)=0.
c      dmzti44(5)=0.
c
      idep=1
c---------------------------
c  five o-si-s shells
c      nrmod=5
c      v1=1133.
c      fill=0.24/5
c      vm=2000
c      fivm3=fill*(vm**3)
c      vrmod(1)=1133.
c      vrmod(2)=1280.
c      vrmod(3)=1398.
c      vrmod(4)=1500.
c      vrmod(5)=1398.
c      vrmod(6)=1500.
c      dm=0.4
c      zden(3)=4.15e8
c      ameanmod(3)=17.6
c      vrmod(1)=v1
c      rmod(1)=vrmod(1)*1.e5*400.*24.*3600.
c      do i=1,5
c         vrmod(i+1)=(vrmod(i)**3.+fivm3)**(1./3.)
c         rmod(i+1)=vrmod(i+1)*1.e5*400.*24.*3600.
c         izmod(i)=3
c         rlab(i)=' o-si-s '
c         dmmod(i)=dm
c         denmod(i)=zden(3)
c         dmzni56(i)=0.
c         dmzni57(i)=0.
c         dmzti44(i)=0.
c      enddo
c---------------------------
c a single o-si-s shell; to compare with i87acl
c      nrmod=1
c      tdmod=1000.
c      fill=0.1
cc
c      vmax=1500.
c      v1=((1-fill)*vmax**3)**0.333333
cc
c      vrmod(1)=v1
c      vrmod(2)=vmax
c      rmod(1)=vrmod(1)*1.e5*tdmod*24.*3600.
c      rmod(2)=vrmod(2)*1.e5*tdmod*24.*3600.
c      izmod(1)=3
c      rlab(1)=' o-si-s '
c      dmmod(1)=2.0
c      ameanmod(3)=17.6
c      volz=4.*pi*(rmod(2)**3-rmod(1)**3)/3.
c      denmod(1)=(dmmod(1)*msun)/(volz*ameanmod(3)*amu)
c      dmzni56(1)=0.
c      dmzni57(1)=0.
c      dmzti44(1)=0.
c---------------------------
c a single he shell
c      nrmod=1
c      tdmod=500.
c      fill=0.1
c
c      vmax=1000.
c      v1=((1-fill)*vmax**3)**0.333333
c
c      vrmod(1)=v1
c      vrmod(2)=vmax
c     rmod(1)=vrmod(1)*1.e5*tdmod*24.*3600.
c      rmod(2)=vrmod(2)*1.e5*tdmod*24.*3600.
c     izmod(1)=3
c      rlab(1)=' o-si-s '
c      dmmod(1)=2.0
c      ameanmod(3)=17.6
c      volz=4.*pi*(rmod(2)**3-rmod(1)**3)/3.
c      denmod(1)=(dmmod(1)*msun)/(volz*ameanmod(3)*amu)
c      dmzni56(1)=0.
c      dmzni57(1)=0.
c      dmzti44(1)=0.
c---------------------------
c      nrmod=1
c      nrmod=2
c      rmod(1)=0.0d0
c      rmod(2)=1.728d15
c      rmod(3)=1.8431d15
c      vrmod(1)=0.0d0
c      vrmod(2)=500.d0
c      vrmod(3)=533.29d0
c      dmmod(1)=2.0
c      dmmod(2)=2.0d-2
c      denmod(1)=5.04d6
c      denmod(2)=1.74d8
c      ameanmod(1)=27.05
c      ameanmod(2)=30.30
c      dmzni56(1)=0.
c      dmzni56(2)=4.73d-4
c      dmzni57(1)=0.
c      dmzni57(2)=2.25d-5
c      dmzti44(1)=3.40d-6
c      dmzti44(2)=0.
c---------------------------
c  three o-si-s shells
c      nrmod=3
c      fill=0.24/3
c      vm=2000
c      fivm3=fill*(vm**3)
c      vrmod(1)=1133.
c      vrmod(2)=1280.
c      vrmod(3)=1398.
c      vrmod(4)=1500.
c      vrmod(5)=1398.
c      vrmod(6)=1500.
c      dm=0.6667
c      zden(3)=4.15e8
c      ameanmod(3)=17.6
c      vrmod(1)=
c      rmod(1)=vrmod(1)*1.e5*400.*24.*3600.
c      do i=1,5
c         vrmod(i+1)=(vrmod(i)**3.+fivm3)**(1./3.)
c         rmod(i+1)=vrmod(i+1)*1.e5*400.*24.*3600.
c         izmod(i)=3
c         rlab(i)=' o-si-s '
c         dmmod(i)=dm
c         denmod(i)=zden(3)
c         dmzni56(i)=0.
c         dmzni57(i)=0.
c         dmzti44(i)=0.
c      enddo
c---------------------------
c  three he shells; with spread-out gamma-source
c      nrmod=11
c      tdmod=400.
c zone 1 is an 'empty' fe-he zone
c zone 2 is empty
c zone 3 is an he zone
c zone 4 is an empty zone
c zone 5 is an fe-he zone
c zone 6 is an empty zone
c zone 7 is an he zone
c zone 8 is an empty zone
c zone 9 is an fe-he zone
c zone 10 is an empty zone
c zone 11 is an he zone
c      vrmod(1)=0.
c      vrmod(2)=500.
c      vrmod(3)=747.9
c      vrmod(4)=1068.0
c      vrmod(5)=1167.6
c      vrmod(6)=1493.2
c      vrmod(7)=1535.8
c      vrmod(8)=1641.4
c      vrmod(9)=1686.4
c      vrmod(10)=1869.4
c      vrmod(11)=1897.0
c      vrmod(12)=1968.4
c      do i=1,nrmod+1
c         rmod(i)=vrmod(i)*1.e5*400.*24.*3600.
c      enddo
c      do i=1,nrmod
c         dmmod(i)=0.
c         denmod(i)=0.
c         rlab(i)=' empty  '
c         dmzni56(i)=0.
c         dmzni57(i)=0.
c         dmzti44(i)=0.
c      enddo
c      izmod(3)=5
c      izmod(7)=5
c      izmod(11)=5
c      rlab(3)=' he     '
c      rlab(7)=' he     '
c     rlab(11)=' he     '
c      dmmod(3)=0.5
c      dmmod(7)=0.5
c      dmmod(11)=1.
cc      zden(5)=1.3773e9
cc      denmod(3)=zden(5)
cc      denmod(7)=zden(5)
cc      denmod(11)=zden(5)
c      ameanmod(5)=4.24
c      volz=4.*pi*(rmod(4)**3-rmod(3)**3)/3.
c      denmod(3)=(dmmod(3)*msun)/(volz*ameanmod(5)*amu)
c      volz=4.*pi*(rmod(8)**3-rmod(7)**3)/3.
c      denmod(7)=(dmmod(7)*msun)/(volz*ameanmod(5)*amu)
c      volz=4.*pi*(rmod(12)**3-rmod(11)**3)/3.
c      denmod(11)=(dmmod(11)*msun)/(volz*ameanmod(5)*amu)
cc      dmzni56(1)=2.38e-3
cc      dmzni57(1)=1.1328e-4
cc      dmzti44(1)=3.4019e-6
cc      dmzni56(5)=3.31e-2
cc      dmzni57(5)=1.5746e-3
cc      dmzti44(5)=4.7286e-5
cc      dmzni56(9)=3.31e-2
cc      dmzni57(9)=1.5746e-3
cc      dmzti44(9)=4.7286e-5
c      dmzni56(1)=3.43e-2
c      dmzni57(1)=1.63e-3
c      dmzti44(1)=4.90e-5
c      dmzni56(5)=1.71e-2
c      dmzni57(5)=8.16e-4
c      dmzti44(5)=2.45e-5
c      dmzni56(9)=1.71e-2
c      dmzni57(9)=8.16e-4
c      dmzti44(9)=2.45e-5
c central point source
cc      idep=1
c spread out source
c      idep=0
c  izm is the last shell containing radiactive elements
c      izm=9
c---------------------------
c  one he shells; test
c      nrmod=1
c      tdmod=490.
c      vrmod(1)=925.
c      vrmod(2)=1060.
c      do i=1,nrmod+1
c         rmod(i)=vrmod(i)*1.e5*tdmod*24.*3600.
c      enddo
c      izmod(1)=5
c      rlab(1)=' he     '
c      dmmod(1)=0.67
cc      ameanmod(5)=4.24
c      ameanmod(5)=2.*4.24
c      volz=4.*pi*(rmod(2)**3-rmod(1)**3)/3.
c      denmod(1)=(dmmod(1)*msun)/(volz*ameanmod(5)*amu)
c      dmzni56(1)=0.
c      dmzni57(1)=0.
c      dmzti44(1)=0.
c central point source
c      idep=1
c---------------------------
c  one h - shell; test
c      nrmod=1
c      tdmod=400.
c      vrmod(1)=1060.
c      vrmod(2)=1168
c      do i=1,nrmod+1
c         rmod(i)=vrmod(i)*1.e5*tdmod*24.*3600.
c      enddo
c      izmod(1)=6
c      rlab(1)=' h      '
c      dmmod(1)=0.67
c      ameanmod(6)=1.43
c      volz=4.*pi*(rmod(2)**3-rmod(1)**3)/3.
c      denmod(1)=(dmmod(1)*msun)/(volz*ameanmod(5)*amu)
c      dmzni56(1)=0.
c      dmzni57(1)=0.
c      dmzti44(1)=0.
c central point source
c      idep=1
c---------------------------
c
      return
      end








