      subroutine sf(xelin,abin,iexfl,iatafl,ifail,ph,peie,pem,pim,
     &     pio,xieff,nlx,nik0)
      IMPLICIT REAL(A-H,O-Z)
      REAL KE
C
      INCLUDE 'INCLUDE/PARAM.SF'
      INCLUDE 'INCLUDE/DATIE.SF'
c
c******************************************
c  this file is the same as sfjh.f in 
c  /hp1/users/cecilia/SF/SFNM/sfjh.f
c******************************************
C
C     the lines marked with cse should be changed when
C     skipping the secondary electrons.
C
C     check the lines marked with cx! before running the program !
C
C     E : ENERGIES IN eV
C     CROSS SECTIONS : CM**2
C     
C     THE SAME PROGRAM AS sfck.f BUT IN 'ENKEL PRECISION'     
c
c  iexfl = 1  :  excitations included
c          0  :  no excitations included
C
c  ifail = 1  :  the run failed
c        = 0  :  the run OK
c
c  iatafl= 1  :  atan for every,given energy bin are calc.
c          0  :  atan for the energy bins are not calc.
c
C     THE ELEMENTS INCLUDED ARE GIVEN IN FILE 'DATIE'
C
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CY/Y(IMAX)
      COMMON/CMQ/MQ
      COMMON/CELEM/IE,IL
      COMMON/CEBINSF/TRATE,DL,DC
      COMMON/CHL/TINI,PHX,PE,PI
      COMMON/COUT/PEIEX(MIE),PEMX(MIE,MIL),PIMX(MIE),PIOX(4),
     &     XIEFFX(MIE)
      COMMON/CATAN/FATAN(MIE,IMAX)
      DIMENSION ABIN(MIE)
      dimension peie(mie),pem(mie,mil),pim(mie),pio(4)
      dimension xieff(mie),nlx(mie)
      DIMENSION A(IMAX)
      SAVE /CATAN/
C
      xel=xelin
      do i=1,mie
        ab(i)=abin(i)
      enddo
c
      phx=0.
      do ie=1,mie
         peiex(ie)=0.
         pimx(ie)=0.
         xieffx(ie)=0.
         do il=1,mil
            pemx(ie,il)=0.
         enddo
      enddo
      do i=1,4
         piox(i)=0.
      enddo
c
      ifail=0
c
      NIK=NIK0
      READ(9,*) EMAX
c      READ(9,*) NIK
      READ(9,*) EDT
      READ(9,*) IEMAX
      READ(9,*) DL
      READ(9,*) DC
      READ(9,*) IWREY            
      rewind(9)
C
      CALL EION
      CALL EEX(iexfl)
      CALL EBINS
      CALL SIGS
      IF (IATAFL.EQ.1) CALL ATANR
C
      DO I=1,IMAX
         A(I)=0.  
         Y(I)=0.
      ENDDO
C
      DO I=NIK-1,1,-1
        DO J=1,IMAX
           A(J)=0.
        ENDDO
        Y(I)=0.
        T=E(I)
c
c  The source term.
c
        IF (T.GT.(EMAX-EDT)) THEN
           B=(EMAX-T)/EDT 
        ELSE
           B=1.
        ENDIF
C
C  The diagonal matrix elements :
C
c  Heat
        A(I)=KE(T)
C
        DO IE=1,IEMAX
          IF (AB(IE).LE.0.) GOTO 9
          XIE=XI(IE)  
          XJ=.6*XIE
C
          TSEC=2.*T+XIE
          ISEC=NIK
          IF (TSEC.LT.EMAX) THEN
            DO II=NIK,I,-1
              IF (E(II).LT.TSEC) THEN
                ISEC=II
                GOTO 10
              ENDIF
            ENDDO
          ENDIF 
 10       CONTINUE
C
          DO IL=1,NL(IE)
c
c  Excitation term
c
            TEX=T+EX(IE,IL)
            IF (E(I+1).GT.TEX) THEN
               TXMEI=TEX-E(I)
               DTII=TXMEI*(1.+(E(I+1)-TEX)/DT(I))
               A(I)=A(I)+.5*DTII*SE(IE,IL,I)*AB(IE)
               DTIP1=(TXMEI*TXMEI)/DT(I)
               A(I+1)=A(I+1)+.5*DTIP1*SE(IE,IL,I)*AB(IE)
            ELSE 
               A(I)=A(I)+.5*DT(I)*SE(IE,IL,I)*AB(IE)
            ENDIF
          ENDDO  
c
c  Primary electron ionization
c
          T1=XIE
          T2=(T+XIE)*.5
c          if (t.gt.xie) then
C          DCSC=SI(IE,I)/ATAN((T-XIE)/(2.*XJ))
c          else
c          dcsc=0.0
c          endif
          IF (T1.LT.T2) THEN
C             DCSC=SI(IE,I)/FATAN(IE,I)
C            X1=(T1-XIE)/XJ
C             X2=(T2-XIE)/XJ
C            S1=DCSC*(ATAN(X2)-ATAN(X1))
C             S1=DCSC*FATAN(IE,I)
             S1=SI(IE,I)
          ELSE
             S1=0.
          ENDIF
          A(I)=A(I)+.5*DT(I)*S1*AB(IE)
C
C  The non-diagonal matrix elements :
C
          DO J=I+1,NIK-1
C
C            DCSC=SI(IE,J)/ATAN((E(J)-XIE)/(2.*XJ))
            if (e(j).gt.xie) then
               DCSC=SI(IE,J)/FATAN(IE,J)
            else
               dcsc=0.0
            endif
C
            DO IL=1,NL(IE)
c
c  Excitation term
c
              TEX=T+EX(IE,IL)
              IF (E(J).LE.TEX) THEN
                IF (E(J+1).LT.TEX) THEN
                  A(J)=A(J)+.5*(DT(J-1)+DT(J))*SE(IE,IL,J)*AB(IE)
                ELSE
                  TMEJ=TEX-E(J)
                  DTJ=DT(J-1)+TMEJ+TMEJ*(E(J+1)-TEX)/DT(J)
                  A(J)=A(J)+.5*DTJ*SE(IE,IL,J)*AB(IE)
                  DTJP1=TMEJ*TMEJ/DT(J)
                  A(J+1)=A(J+1)+.5*DTJP1*SE(IE,IL,J+1)*AB(IE)
                ENDIF
              ENDIF
            ENDDO  
c
c  Primary electron ionization
c
            T1=E(J)-T
            IF (T1.LT.XIE) T1=XIE
            T2=(E(J)+XIE)*.5
            IF (T1.LT.T2) THEN
              X1=(T1-XIE)/XJ
C              X2=(T2-XIE)/XJ
C              S2=DCSC*(ATAN(X2)-ATAN(X1))
              S2=DCSC*(FATAN(IE,J)-ATAN(X1))
            ELSE
              S2=0.
            ENDIF
            A(J)=A(J)+.5*(DT(J-1)+DT(J))*S2*AB(IE)
c
c  Secondary electron ionization 
c
cse            goto 777
            IF (J.GE.ISEC) THEN
              T1=T+XIE
              T2=(E(J)+XIE)*.5
              IF (T1.LT.T2) THEN
                X1=(T1-XIE)/XJ
C                X2=(T2-XIE)/XJ
C                S3=DCSC*(ATAN(X2)-ATAN(X1))
                S3=DCSC*(FATAN(IE,J)-ATAN(X1))
              ELSE
                S3=0.
              ENDIF
              IF(J.EQ.ISEC) THEN
                EMTS=E(ISEC+1)-TSEC  
                DTIS=EMTS*EMTS/DT(ISEC)  
                A(J)=A(J)-.5*DTIS*S3*AB(IE)
              ELSEIF (J.EQ.ISEC+1) THEN
                EMTS=E(ISEC+1)-TSEC  
                DTISP1=DT(ISEC+1)+EMTS+EMTS*(TSEC-E(ISEC))/DT(ISEC)  
                A(J)=A(J)-.5*DTISP1*S3*AB(IE)
              ELSE
                A(J)=A(J)-.5*(DT(J-1)+DT(J))*S3*AB(IE)
              ENDIF        
            ENDIF
  777       continue
          ENDDO
 9        CONTINUE
        ENDDO
C
        SUMAY=0.
        DO J=I+1,NIK-1
           SUMAY=SUMAY+A(J)*Y(J)
        ENDDO
        Y(I)=(B-SUMAY)/A(I)
        IF (Y(I).LE.0.) THEN
           IFAIL=1
c           WRITE(6,*) ' Y NEGATIVE FOR ', I
           Y(I)=0.
        ENDIF
C
      ENDDO
C
C   CHECK IF Y:s ARE OK (IF THEY ARE UNSTABLE SOME WILL BE LESS THAN 
C   ZERO).
C
C      IF (IFAIL.EQ.1) GOTO 999
C2
C1
cjohn      IF (IWREY.EQ.1) THEN            
cjohn        OPEN(22,FILE='sfeyout')
cjohn        DO I=1,NIK-1
cjohn          WRITE(22,701) E(I),Y(I)
cjohn        ENDDO
cjohn        CLOSE(22)
cjohn      ENDIF
C
      CALL HEI
C
C      CALL FRACSE
 999  CONTINUE
C
 701  FORMAT(2E12.4)
 702  FORMAT(I4,3E12.4)
c
      ph=phx
      do ie=1,mie
         peie(ie)=peiex(ie)
         pim(ie)=pimx(ie)
         xieff(ie)=xieffx(ie)
         nlx(ie)=nl(ie)
         do il=1,nl(ie)
            pem(ie,il)=pemx(ie,il)
         enddo
      enddo
      do i=1,4
         pio(i)=piox(i)
      enddo
c
      RETURN
      END




      FUNCTION F(T)
C
      IMPLICIT REAL(A-H,O-Z)
      REAL LAMB
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CMQ/MQ
      COMMON/CTIN/TIN
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CELEM/IE,IL
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CY/Y(IMAX)
      DATA ERR/0.05/
C
      MQIN=MQ
      TIN=T
      IF (T.GE.(EMAX-EDT)) THEN
        S=1./EDT
      ELSE
        S=0.
      ENDIF
      FSUM=S
      DO IE=1,IEMAX
        IF (AB(IE).LE.0.) GOTO 9
        A1=0.
c
c  A1 : the excitation term
c
        DO IL=1,NL(IE)
          E1=EX(IE,IL)
          IF ((T+E1).LT.E(NIK)) THEN
            DO I=1,IMAX
              IF (E(I).GT.(T+E1)) THEN
                IF (I.EQ.1) YT=0.
                IF (I.GT.1) THEN
                  YT=Y(I)-((E(I)-(T+E1))/(E(I)-E(I-1)))*(Y(I)-Y(I-1))
                ENDIF          
                IS=I
                GOTO 100
              ENDIF
            ENDDO
 100        CONTINUE
            TE1=T+E1
            SIGE=SE(IE,IL,IS)+((E(IS)-TE1)/DT(IS-1))*(SE(IE,IL,IS)
     &          -SE(IE,IL,IS-1))
            A1=SIGE*YT+A1
          ENDIF
        ENDDO
c
c  A2 : primary electron ionization term
c
        LAMB=MIN(EMAX-T,T+XI(IE))
        MQ=5
        IF (LAMB.GT.XI(IE)) THEN
          CALL ROMBF(XI(IE),LAMB,ERR,A2,FAIL,K)
        ELSE
          A2=0.
        ENDIF
C        CALL SIMPAF(21,XI(IE),LAMB,A2)
c
c  A3 : secondary electron ionization term
c
        AS=2*T+XI(IE)
        MQ=6
        IF (E(NIK).GT.AS.AND.TIN.GT.0.) THEN
          CALL ROMBF(AS,E(NIK),ERR,A3,FAIL,K)
        ELSE
          A3=0.
        ENDIF
cse        A3=0.
C        CALL SIMPAF(21,AS,E(NIK),A3)
C
        FSUM=AB(IE)*(A1+A2+A3)+FSUM
C
 9      CONTINUE
      ENDDO
      F=FSUM
      MQ=MQIN
C
      RETURN
      END




      REAL FUNCTION KE(T)
C
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
C
      DATA PI/3.1415926E0/,ELCH/1.60219E-12/,EMASS/9.1091E-28/
      DATA HPL/6.626E-27/,EESU/4.803E-10/
C
      DEL=1.e8
      CONST=XEL*(2.*PI*EESU**4/(T*elch**2))
      IF (T.GT.14) THEN
        ZATA=(HPL/PI)*SQRT(4.*PI*DEL*EESU**2/EMASS)/ELCH
        KE=CONST*LOG(4*T/ZATA)
      ELSEIF (T.LE.14) THEN
        KE=CONST*(0.5*LOG(T**3/DEL)+23.95)
      ENDIF
C
      RETURN
      END



      SUBROUTINE ABUN(ABIN,ISTART)
      IMPLICIT REAL(A-H,O-Z)
      INCLUDE 'INCLUDE/PARAM.SF'
      INCLUDE 'INCLUDE/DATIE.SF'
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      DIMENSION ABIN(MIE)
C
      IF (ISTART.EQ.0) THEN
        OPEN(8,FILE='abunin',status='old')
C
        DO I=1,IEMAX
          READ(8,*) ABIN(I)
          IF (ABIN(I).LT.1.E-9) ABIN(I)=0.
          AB(I)=ABIN(I)  
        ENDDO
C
        SUAB=0.
        DO I=1,IEMAX
          SUAB=SUAB+ABIN(I)  
        ENDDO
        DO I=1,IEMAX
          ABIN(I)=ABIN(I)/SUAB
        ENDDO
C
C  IF THE ABUNDANCE FOR A NEUTRAL ELEMENT IS NONZERO THE CORRESPONDING
C  ION IS ALSO GIVEN SOME ARBITRARY NONZERO VALUE, JUST TO CALCULATE
C  ALL THE NECESSARY CROSS SECTIONS IN THE SUBROUTINE SIGS.
C  WHEN THE ELECTRON FRACTION IS GIVEN THIS ABUNDANCES ARE CORRECTED.   
C
C  HE I   
        IF (AB(IHE1).GT.0) AB(IHE2)=AB(IHE1)
C  C I   
        IF (AB(IC1).GT.0) AB(IC2)=AB(IC1)
C  N I   
        IF (AB(IN1).GT.0) AB(IN2)=AB(IN1)
C  O I   
        IF (AB(IO1).GT.0) AB(IO2)=AB(IO1)
C  NA I
        IF (AB(INA1).GT.0) AB(INA2)=AB(INA1)
C  MG I
        IF (AB(IMG1).GT.0) AB(IMG2)=AB(IMG1)
C  SI I
        IF (AB(ISI1).GT.0) AB(ISI2)=AB(ISI1)
C  S I
        IF (AB(IS1).GT.0) AB(IS2)=AB(IS1)
C  CA I
        IF (AB(ICA1).GT.0) AB(ICA2)=AB(ICA1)
C  FE I
        IF (AB(IFE1).GT.0) AB(IFE2)=AB(IFE1)
C
      ELSE
C
C  FOR A CERTAIN ELECTRON FRACTION THE APPROPRIATE ABUNDANCES
C  FOR NEUTRALS AND IONS ARE GIVEN.
C
        DO I=1,IEMAX
          AB(I)=ABIN(I)  
        ENDDO
C
C  SPECIAL TREATMENT FOR NA AND CA
C  THEY ARE ASSUMED TO BE MAINLY IONIZED
C
        CANASUM=0.99*ABIN(INA1)+0.99*ABIN(ICA1)
        IF (XEL.GE.CANASUM) THEN
C  NA 
          AB(INA1)=.01*ABIN(INA1)
          AB(INA2)=.99*ABIN(INA1)  
C  CA
          AB(ICA1)=0.01*ABIN(ICA1)
          AB(ICA2)=0.99*ABIN(ICA1)
C
          XELEFF=XEL-CANASUM  
        ELSEIF (XEL.LT.CANASUM) THEN
          ABSUM=ABIN(INA1)+ABIN(ICA1)
C  NA
          AB(INA2)=(ABIN(INA1)/ABSUM)*XEL
          AB(INA1)=ABIN(INA1)-AB(INA2)
C  CA
          AB(ICA2)=(ABIN(ICA1)/ABSUM)*XEL
          AB(ICA1)=ABIN(ICA1)-AB(ICA2)
C
          XELEFF=1.E-6
C
        ENDIF
        IF (XELEFF.LT.1.E-6) XELEFF=1.E-6
C
C  THE REST OF THE ELEMENTS ARE ASSUMED TO BE
C  IONIZED PROPORTIONAL TO THE ELECTRON FRACTION
C
        ABSUM=0.
        DO I=1,IEMAX
          ABSUM=ABSUM+ABIN(I)
        ENDDO
        ABSUM=ABSUM-ABIN(INA1)-ABIN(ICA1)
C  H I
C        IF (ABIN(IH1).GT.0.) AB(IH1)=ABIN(IH1)*(1.-XELEFF)
        IF (ABIN(IH1).GT.0.) AB(IH1)=ABIN(IH1)*(1.-XELEFF/ABSUM)
C  HE I   
        IF (ABIN(IHE1).GT.0) THEN
C          AB(IHE2)=ABIN(IHE1)*XELEFF
C          AB(IHE1)=ABIN(IHE1)*(1.-XELEFF)
          AB(IHE2)=(ABIN(IHE1)/ABSUM)*XELEFF
          AB(IHE1)=ABIN(IHE1)-AB(IHE2)
        ENDIF
C  C I   
        IF (ABIN(IC1).GT.0) THEN
C          AB(IC1)=ABIN(IC1)*(1.-XELEFF)
C          AB(IC2)=ABIN(IC1)*XELEFF
          AB(IC2)=(ABIN(IC1)/ABSUM)*XELEFF
          AB(IC1)=ABIN(IC1)-AB(IC2)
        ENDIF
C  N I   
        IF (ABIN(IN1).GT.0) THEN
C          AB(IN1)=ABIN(IN1)*(1.-XELEFF)
C          AB(IN2)=ABIN(IN1)*XELEFF
          AB(IN2)=(ABIN(IN1)/ABSUM)*XELEFF
          AB(IN1)=ABIN(IN1)-AB(IN2)
        ENDIF
C  O I   
        IF (ABIN(IO1).GT.0) THEN
C          AB(IO1)=ABIN(IO1)*(1.-XELEFF)
C          AB(IO2)=ABIN(IO1)*XELEFF
          AB(IO2)=(ABIN(IO1)/ABSUM)*XELEFF
          AB(IO1)=ABIN(IO1)-AB(IO2)
        ENDIF
C  NE I
        IF (ABIN(INE1).GT.0.) AB(INE1)=ABIN(INE1)*(1.-XELEFF/ABSUM)
C  MG I
        IF (ABIN(IMG1).GT.0) THEN
C          AB(IMG1)=ABIN(IMG1)*(1.-XELEFF)
C          AB(IMG2)=ABIN(IMG1)*XELEFF
          AB(IMG2)=(ABIN(IMG1)/ABSUM)*XELEFF
          AB(IMG1)=ABIN(IMG1)-AB(IMG2)
        ENDIF
C  SI I
        IF (ABIN(ISI1).GT.0) THEN
C          AB(ISI1)=ABIN(ISI1)*(1.-XELEFF)
C          AB(ISI2)=ABIN(ISI1)*XELEFF
          AB(ISI2)=(ABIN(ISI1)/ABSUM)*XELEFF
          AB(ISI1)=ABIN(ISI1)-AB(ISI2)
        ENDIF
C  S I
        IF (ABIN(IS1).GT.0) THEN
C          AB(IS1)=ABIN(IS1)*(1.-XELEFF)
C          AB(IS2)=ABIN(IS1)*XELEFF
          AB(IS2)=(ABIN(IS1)/ABSUM)*XELEFF
          AB(IS1)=ABIN(IS1)-AB(IS2)
        ENDIF
C  AR I
        IF (ABIN(IAR1).GT.0.) AB(IAR1)=ABIN(IAR1)*(1.-XELEFF/ABSUM)
C  FE I
        IF (ABIN(IFE1).GT.0) THEN
C          AB(IFE1)=ABIN(IFE1)*(1.-XELEFF)
C          AB(IFE2)=ABIN(IFE1)*XELEFF
          AB(IFE2)=(ABIN(IFE1)/ABSUM)*XELEFF
          AB(IFE1)=ABIN(IFE1)-AB(IFE2)
        ENDIF
C  CO I
        IF (ABIN(ICO1).GT.0.) AB(ICO1)=ABIN(ICO1)*(1.-XELEFF/ABSUM)
C  NI I
        IF (ABIN(INI1).GT.0.) AB(INI1)=ABIN(INI1)*(1.-XELEFF/ABSUM)
C
      ENDIF
      ABSUM=0.
      DO I=1,IEMAX
        ABSUM=ABSUM+AB(I)
      ENDDO
      IF (ABSUM.GT.1) WRITE(*,701) 'ABSUM=',ABSUM
      DO I=1,IEMAX
        IF (AB(I).LT.0.) WRITE(*,702) ' I, AB', I,AB(I)
      ENDDO
C
 701  FORMAT(A,E12.4)
 702  FORMAT(A,I4,E12.4)
      RETURN
      END


      FUNCTION DSIGX(IE,T,EN,IS)
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
C   DIFFERENTIAL CROSSECTIONS
C
C   IS : E(IS-1) < T < E(IS)
C      
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
C
      U=T/XI(IE)
      DSIGX=0.
      IF (U.LE.1.) GOTO 99
      IF (AB(IE).LE.0.) GOTO 99
      IF (EN.LE.XI(IE)) GOTO 99
      XJ=.6*XI(IE)
      PET=1./((XJ*ATAN((T-XI(IE))/(2.*XJ)))*(1.+
     &    ((EN-XI(IE))/XJ)**2))      
      SIGI=SI(IE,IS-1)+((T-E(IS-1))/DT(IS-1))*(SI(IE,IS)-SI(IE,IS-1))
      DSIGX=SIGI*PET
      if (dsigx.lt.0.) then
         write(*,701) 'dsigx=',ie,is,t,dsigx
      endif
 99   CONTINUE
C
 701  format(a,2i4,2e12.4)
      RETURN
      END


      FUNCTION DSIG1(IE,T,EN,IS)
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
C   DIFFERENTIAL CROSSECTIONS
C
C   IS : E(IS-1) < T < E(IS)
C      
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CATAN/FATAN(MIE,IMAX)
C
      U=T/XI(IE)
      DSIG1=0.
      IF (U.LE.1.) GOTO 99
      IF (AB(IE).LE.0.) GOTO 99
      IF (EN.LE.XI(IE)) GOTO 99
      XJ=.6*XI(IE)
      if (fatan(ie,is-1).gt.0.) then
         PET1=1./((XJ*FATAN(IE,IS-1))*(1.+
     &        ((EN-XI(IE))/XJ)**2))      
      else
         pet1=0.
      endif
      PET2=1./((XJ*FATAN(IE,IS))*(1.+
     &    ((EN-XI(IE))/XJ)**2))      
      SIG1=SI(IE,IS-1)
      SIG2=SI(IE,IS)
      DSIG1=PET1*SIG1+((T-E(IS-1))/DT(IS-1))*(PET2*SIG2-PET1*SIG1)
      if (dsig1.lt.0.) then
         write(*,701) 'dsig1=',ie,is,t,dsig1
      endif
 99   CONTINUE
C
 701  format(a,2i4,2e12.4)
      RETURN
      END



      FUNCTION DSIG(IE,T,EN,IT)
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
C   DIFFERENTIAL CROSSECTIONS
C
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
C
      U=T/XI(IE)
      DSIG=0.
      IF (U.LE.1.) GOTO 99
      IF (AB(IE).LE.0.) GOTO 99
      IF (EN.LE.XI(IE)) GOTO 99
      XJ=.6*XI(IE)
      PET=1./((XJ*ATAN((T-XI(IE))/(2.*XJ)))*(1.+
     &    ((EN-XI(IE))/XJ)**2))      
      DSIG=SI(IE,IT)*PET
 99   CONTINUE
C
      RETURN
      END


      SUBROUTINE SIGS
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/COI/NOIF
C
      NOIF=0
C
      DO I=1,NIK
        DO IE=1,IEMAX
          DO IL=1,NL(IE)  
            SE(IE,IL,I)=0.
          ENDDO
          SI(IE,I)=0.
        ENDDO
      ENDDO  
C
      DO I=1,NIK
        T=E(I)
        DO IE=1,IEMAX
          IF (AB(IE).LE.0.) GOTO 9
          DO IL=1,NL(IE)
            SE(IE,IL,I)=FSIGE(IE,IL,T)
          ENDDO        
          SI(IE,I)=FSIGI(IE,T)
 9        CONTINUE
        ENDDO
      ENDDO
C
      RETURN
      END




      SUBROUTINE ROMBSF(AA,BB,ERR,FI,FAIL,K)
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION TR(100),W(100)
      A=AA
      B=BB
c      A=DBLE(AA)
c      B=DBLE(BB)
      DX=(B-A)/2.
      FI1=0.5*(FXSF(A)+FXSF(B))
      FI2=FXSF(A+DX)
      TR(1)=DX*(FI1+FI2)
      N=1
      K=1
      W(1)=4.
1     FI=TR(1)
      W(K+1)=4.*W(K)
      N=2*N
      K=K+1
      TDX=DX
      DX=DX/2.
      X=A+DX
      DO 2 I=1,N
      FI2=FI2+FXSF(X)
2     X=X+TDX
      TR(K)=DX*(FI1+FI2)
      KK=K-1
      DO 3 J=1,KK
      M=K-J
3     TR(M)=(W(J)*TR(M+1)-TR(M))/(W(J)-1.)
      FAIL=ABS(TR(1)-FI)/ABS(TR(1))
      IF(FAIL-ERR)6,6,4
4     IF(K-100)1,6,6
6     FI=TR(1)
      RETURN
      END


      SUBROUTINE ROMBF(AA,BB,ERR,FI,FAIL,K)
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION TR(100),W(100)
      A=AA
      B=BB
c      A=DBLE(AA)
c      B=DBLE(BB)
      DX=(B-A)/2.
      FI1=0.5*(FXSF(A)+FXSF(B))
      FI2=FXSF(A+DX)
      TR(1)=DX*(FI1+FI2)
      N=1
      K=1
      W(1)=4.
1     FI=TR(1)
      W(K+1)=4.*W(K)
      N=2*N
      K=K+1
      TDX=DX
      DX=DX/2.
      X=A+DX
      DO 2 I=1,N
      FI2=FI2+FXSF(X)
2     X=X+TDX
      TR(K)=DX*(FI1+FI2)
      KK=K-1
      DO 3 J=1,KK
      M=K-J
3     TR(M)=(W(J)*TR(M+1)-TR(M))/(W(J)-1.)
      FAIL=ABS(TR(1)-FI)/ABS(TR(1))
      IF(FAIL-ERR)6,6,4
4     IF(K-100)1,6,6
6     FI=TR(1)
      RETURN
      END



      SUBROUTINE HEI
C
C     CALCULATES THE FRACTIONS GOING INTO HEATING (PH), EXCITATION (PE),
C     AND IONIZATION (PI).
C
      IMPLICIT REAL(A-H,O-Z)
      REAL KE
C
      INCLUDE 'INCLUDE/PARAM.SF'
      INCLUDE 'INCLUDE/DATIE.SF'
C
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CELEM/IE,IL
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CMQ/MQ
      COMMON/CHL/TINI,PH,PE,PI
      COMMON/CY/Y(IMAX)
      COMMON/COI/NOIF
      COMMON/COUT/PEIE(MIE),PEM(MIE,MIL),PIM(MIE),PIO(4),
     &     XIEFF(MIE)
      common/cwr/tiniwr,ph1,ph2,ph3
c      DIMENSION XIO(4)
      DATA ERR/0.01/
C
      TINI=E(NIK)-EDT/2.
C
C     HEATING
C
      MQ=1
      CALL ROMBSF(EXMIN,E(NIK),ERR,PH1,FAIL,K)
C
      MQ=4
      CALL ROMBSF(0.,EXMIN,ERR,PH2,FAIL,K)
C
      DO I=1,NIK
        IF (E(I).GT.EXMIN) THEN
          YE0=Y(I-1)+((Y(I)-Y(I-1))*(EXMIN-E(I-1))/DT(I-1))  
          GOTO 10
        ENDIF
      ENDDO
 10   CONTINUE
      PH3=YE0*EXMIN*KE(EXMIN)
C
      PH=(PH1+PH2+PH3)/TINI
C
C     EXCITATION
C
      MQ=2
      DO IE=1,IEMAX
        PEIE(IE)=0. 
        IF (AB(IE).GT.0.) THEN
          DO IL=1,NL(IE)  
            CALL ROMBSF(EX(IE,IL),E(NIK),ERR,XK,FAIL,K)
            PEM(IE,IL)=AB(IE)*EX(IE,IL)*XK/TINI
            PEIE(IE)=PEIE(IE)+PEM(IE,IL)
          ENDDO
        ENDIF
      ENDDO
C
      PE=0.
      DO IE=1,IEMAX
        DO IL=1,NL(IE)
          PE=PE+PEM(IE,IL)
        ENDDO
      ENDDO
CJH      PE=SUM(PEM)
C
C     IONIZATION
C
      MQ=3
      NOIF=0
      DO IE=1,IEMAX
        IF (AB(IE).GT.0.) THEN
          CALL ROMBSF(XI(IE),E(NIK),ERR,XK,FAIL,K)
          PIM(IE)=AB(IE)*XI(IE)*XK/TINI
          if (pim(ie).lt.1.e-35) pim(ie)=1.e-35
        ENDIF
      ENDDO
C
C  O I
C  IONIZATION TO 4 DIFFERENT STATES IN O II
C  SEE LAHER AND GILMORE
C  1 : 4So
C  2 : 2Do
C  3 : 2Po
C  4 : 4P
C
      IF (AB(IO1).GT.0.) THEN
C  IONIZATION ENERGIES TO THE DIFFERENT STATES
        IE=IO1
CJH        XIO(1:4)=<13.6,16.9,18.6,28.5>
c        XIO(1)=13.6
c        XIO(2)=16.9
c        XIO(3)=18.6
c        XIO(4)=28.5
        DO I=1,4
          NOIF=I  
c          CALL ROMBSF(XIO(I),E(NIK),ERR,XK,FAIL,K)
c          PIO(I)=AB(IO1)*XIO(I)*XK/TINI
c
c  really the integral should be from XIO(I) as the cross 
c  section should be zero for smaller E. However, the energy bins
c  for the ionization cross section are big, and the interpolation
c  procedure gives sig.ne.0. In order to be consistent and
c  conserve energy the integral is taken from XI. The errors may be 
c  few ( smaller than approx. 5 % (?)) percent. 
c
          CALL ROMBSF(XI(IE),E(NIK),ERR,XK,FAIL,K)
          PIO(I)=AB(IO1)*XI(IE)*XK/TINI
        ENDDO
        NOIF=0
      ENDIF
C
      PI=0.
      DO IE=1,IEMAX
        PI=PI+PIM(IE)
      ENDDO
CJH      PI=SUM(PIM)
C
C   CALCULATE THE EFFECTIVE IONIZATION POTENTIAL
C

      DO IE=1,IEMAX
        IF(AB(IE).GT.0.) THEN
          XIEFF(IE)=XI(IE)/(PIM(IE)/AB(IE))                    
        ENDIF
      ENDDO
C
C2
      SS=PH+PE+PI
C2
      tiniwr=tini
      RETURN
      END


      SUBROUTINE FRACSE
C
      IMPLICIT REAL(A-H,O-Z)
      REAL KE
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CY/Y(IMAX)
      COMMON/CHL/TINI,PH,PE,PI
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
C
      DIMENSION DPEM(MIE,MIL),DPIM(MIE)
C
      DO I=1,MIE
        DPIM(I)=0.
        DO J=1,10
          DPEM(I,J)=0.  
        ENDDO
      ENDDO
      DO I=1,NIK-1
        T=E(I)
        DTF=(E(I+1)-E(I-1))/2.
        dtf=1.
C   HEATING
C
        DPH=Y(I)*KE(T)*DTF/TINI
C
C   EXCITATION
C
        DO IE=1,IEMAX            
          IF (AB(IE).GT.0.) THEN
            DO IL=1,NL(IE)
              DPEM(IE,IL)=AB(IE)*EX(IE,IL)*Y(I)*SE(IE,IL,I)*DTF/TINI
            ENDDO
          ENDIF
        ENDDO
        DPE=0.
        DO IE=1,IEMAX
          DO IL=1,NL(IE)
            DPE=DPE+DPEM(IE,IL)
          ENDDO
        ENDDO
CJH        DPE=SUM(DPEM)
C
C   IONIZATION
C
        DO IE=1,IEMAX
          IF (AB(IE).GT.0.) THEN            
            DPIM(IE)=AB(IE)*XI(IE)*Y(I)*SI(IE,I)*DTF/TINI            
          ENDIF
        ENDDO
        DPI=0.
        DO IE=1,IEMAX
          DPI=DPI+DPIM(IE)
        ENDDO
CJH        DPI=SUM(DPIM)
C

cjh        WRITE(11,700) E(I),DPH,DPE,DPI
        DPH=DPH*T
        DPE=DPE*T
        DPI=DPI*T
c        WRITE(11,700) E(I),LOG10(E(I)),DPH,DPH/T,DPE,DPE/T,DPI,DPI/T  
      ENDDO
C
 700  FORMAT(1pe12.4,20E12.4)
      RETURN
      END


      FUNCTION FXSF(T)
C
      IMPLICIT REAL(A-H,O-Z)
      REAL KE
c
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CELEM/IE,IL
      COMMON/CMQ/MQ
      COMMON/CTIN/TIN
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CY/Y(IMAX)
      COMMON/CHEI/DT(IMAX),EDT,NIK
C
      FXSF=0.0
      IF (MQ.LE.3) THEN
        DO I=1,IMAX
          IF (E(I).GT.T) THEN
            YT=Y(I-1)+(Y(I)-Y(I-1))*(T-E(I-1))/DT(I-1)
            IF (MQ.EQ.1) FXSF=YT*KE(T)
            IF (MQ.EQ.2) FXSF=YT*FSIGE(IE,IL,T)
            IF (MQ.EQ.3) FXSF=YT*FSIGI(IE,T)
            GOTO 100
          ENDIF
        ENDDO
      ELSEIF (MQ.EQ.4) THEN
        FXSF=F(T)*T
      ELSEIF (MQ.EQ.5.OR.MQ.EQ.6) THEN
        IF (MQ.EQ.5) THEN
          XX=TIN+T
          XY=T
        ENDIF
        IF (MQ.EQ.6) THEN
          XX=T
          XY=TIN+XI(IE)
        ENDIF
        DO I=1,IMAX
          IF (E(I).GT.XX) THEN
            IF (I.EQ.1) FXSF=0.
            IF (I.GT.1) THEN
              YX=((XX-E(I-1))/(E(I)-E(I-1)))*(Y(I)-Y(I-1))+Y(I-1)  
              IS=I
C              FXSF=YX*DSIGX(IE,XX,XY,IS)
              FXSF=YX*DSIG1(IE,XX,XY,IS)
            ENDIF
            GOTO 100
          ENDIF
        ENDDO
      ELSEIF (MQ.EQ.7) THEN  
cse 
C
C  SPECIAL CASE. ONLY WHEN NEGLECTING THE SECONDARY ELECTRONS.
C  HAS NEVER BEEN TESTED OR USED !
C
        XJ=0.6*XI(IE)
        X2=0.5*(T-XI(IE))/XJ
        DO I=1,IMAX
          IF (E(I).GT.T) THEN
            YT=Y(I-1)+(Y(I)-Y(I-1))*(T-E(I-1))/DT(I-1)
            FXSF=YT*FSIGI(IE,T)
            GOTO 100
          ENDIF
        ENDDO

      ENDIF
 100  CONTINUE
C
      RETURN
      END



      SUBROUTINE EBINSOLD
      IMPLICIT REAL(A-H,O-Z)
      REAL LEINT
C
      INCLUDE 'INCLUDE/PARAM.SF' 
C
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CEBINSF/TRATE,DL,DC
C
C    HEINT : THE INTERVAL AT HIGH ENERGIES OVER WHICH A FINER GRID
C            IS WANTED
C    LEINT : THE INTERVAL AT LOW ENERGIES OVER WHICH A COARSER GRID
C            IS WANTED 
C    TRATE : TRANSITION "RATE" FROM FINE TO COARSE GRID
C
      TRATE=1.05
      DO I=1,IMAX
        DT(I)=0.
        E(I)=0.
      ENDDO
C
      HEINT=EDT+100.
      IF (HEINT.LT.150.) HEINT=150.
      LEINT=HEINT
C
      E(1)=E0
      E(NIK)=EMAX
C
      GKRIT=(EMAX-E0)/(NIK-1)
      IF (GKRIT.LE.1.) THEN
C
C    IF EMAX IS LOW, USE EQUALLY SPACED ENERGY GRID
C
        DTE=(EMAX-E0)/(NIK-1)
        DO I=1,NIK-1
          DT(I)=DTE
          E(I+1)=E(I)+DT(I)
        ENDDO
        E(NIK)=EMAX  
      ELSE
C
C    IF EMAX HIGH, USE FINER GRID IN THE LOW- AND HIGHENERGY PARTS
C    AND A COARSER GRID IN BETWEEN
C
C    NF = NUMBER OF INTERVALS IN THE FINER GRID REGIONS (LOW/HIGH 
C         ENERGIES)
C
        FRAC=0.60
 111    CONTINUE        
        NF=INT(0.5*FRAC*(NIK-1))
        DTF=LEINT/NF
        NC=NIK-1-NF
C
        DO I=1,NF
          DT(I)=DTF
          E(I+1)=E(I)+DT(I)
          DT(NIK-I)=DTF
          E(NIK-I)=E(NIK-I+1)-DT(NIK-I)
        ENDDO
C
        I1=NF+1
        I2=NIK-NF-1
        DE=E(NIK-NF)-E(NF+1)
        NC=NIK-1-2*NF
C
        IF (TRATE.LE.1.0) GOTO 10
C
        DO I=NF+1,NIK-NF-1
          DTN=TRATE*DT(I-1)
          DTC=DE/NC
          IF (DTN.GE.DTC) THEN
            I1=I
            I2=NIK-I
            GOTO 10
          ENDIF
C
          DT(I)=DTN
          E(I+1)=E(I)+DT(I)
          DT(NIK-I)=DTN
          E(NIK-I)=E(NIK-I+1)-DT(NIK-I)
C
          DE=E(NIK-I)-E(I+1)
          NC=NC-2
          IF (NC.EQ.0.OR.NC.EQ.1) WRITE(*,*) 'EBIN PROBLEMS'          
        ENDDO        
 10     CONTINUE
C
        DTC=DE/NC
        IF (DTC.LT.6.) THEN
          FRAC=FRAC+0.02
          GOTO 111  
        ENDIF
        DO I=I1,I2
          DT(I)=DTC
          E(I+1)=E(I)+DT(I)
        ENDDO
C
      ENDIF
C
      DTSUM=0.
      DO I=1,IMAX
        DTSUM=DTSUM+DT(I)
      ENDDO
CJH      DTSUM=SUM(DT)
C
C      WRITE(6,701) EMAX-E0,DTSUM
C
 701  FORMAT(2E12.4)
      RETURN
      END




      SUBROUTINE EBINS
      IMPLICIT REAL(A-H,O-Z)
      REAL LEINT
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CEBINSF/TRATE,DL,DC
C
C    HEINT : THE INTERVAL AT HIGH ENERGIES OVER WHICH A FINER GRID
C            IS WANTED
C    LEINT : THE INTERVAL AT LOW ENERGIES OVER WHICH A COARSER GRID
C            IS WANTED 
C    TRATE : TRANSITION "RATE" FROM FINE TO COARSE GRID
C
      DO I=1,IMAX
        DT(I)=0.
        E(I)=0.
      ENDDO
C
      E(1)=E0
      E(NIK)=EMAX
C
      GKRIT=(EMAX-E0)/(NIK-1)
      IF (GKRIT.LE.0.5.or.nik.le.700) THEN
c      IF (GKRIT.LE.2.) THEN
C
C    IF EMAX IS LOW, USE EQUALLY SPACED ENERGY GRID
C
        DTE=(EMAX-E0)/(NIK-1)
        DO I=1,NIK-1
          DT(I)=DTE
          E(I+1)=E(I)+DT(I)
        ENDDO
      ELSE
C
C    IF EMAX HIGH (OR NIK LOW), USE FINER GRID IN THE LOW- 
C    AND HIGHENERGY PARTS AND A COARSER GRID IN BETWEEN
C
C    NF = NUMBER OF INTERVALS IN THE FINER GRID REGIONS (LOW/HIGH 
C         ENERGIES)
C
C
        HEINT=EDT+150.
        LEINT=200.
C
C  FOR THE LOW-ENERGY INTERVAL (E<200eV) THE GRIDSIZE(DT) IS 1 EV
C  DL = GRID SIZE FOR THE LOWER ENERGIES
C        
c        DL=1.5
        I=1
        DT(I)=DL
        E(I+1)=E(I)+DT(I)
  11    CONTINUE
        IF (E(I+1).LT.200.) THEN
          I=I+1
          DT(I)=DL
          E(I+1)=E(I)+DT(I)  
          GOTO 11
        ENDIF
C
C  TRANSITION REGION TO COARESER GRID, WITH 'TRANSITIONRATE' = 1.1   
C  DC = THE COARSER GRID SIZE
C
c        DC=15.
  12    CONTINUE
        IF (DT(I).LT.DC) THEN
          I=I+1
          DT(I)=DT(I-1)*1.05
          E(I+1)=E(I)+DT(I)
          GOTO 12
        ENDIF  
C
C  THE COARSE GRID REGION
C
  13    CONTINUE
        IF (E(I+1).LT.(EMAX-HEINT)) THEN              
          I=I+1
          DT(I)=DC
          E(I+1)=E(I)+DT(I)
          GOTO 13
        ENDIF
C
C  TRANSITION REGION FROM COARSER TO FINER HIGH ENERGY GRID
C  'TRANSITION RATE' = 0.9
C 
  14    CONTINUE
        DTH=(E(NIK)-E(I+1))/(NIK-I-1)        
        IF (DT(I).GT.DTH) THEN
          I=I+1
          DT(I)=DT(I-1)*0.95
          E(I+1)=E(I)+DT(I)  
          GOTO 14
        ENDIF
C
C  FINER GRID FOR HIGHER ENERGIES   
C  DH = GRID SIZE FOR THE HIGHER ENERGIES
        DH=DTH
  15    CONTINUE
        IF (I+1.LT.NIK) THEN
          I=I+1
          DT(I)=DH
          E(I+1)=E(I)+DT(I)
          GOTO 15
        ENDIF
C
      ENDIF
      DTSUM=0.
      DO I=1,IMAX
        DTSUM=DTSUM+DT(I)
      ENDDO
CJH      DTSUM=SUM(DT)
C
c      DO I=1,NIK-1
c        WRITE(6,702) I,DT(I),e(i+1)
c      ENDDO
c      WRITE(6,701) EMAX-E0,DTSUM
C
 701  FORMAT(2E12.4)
 702  FORMAT(I5,2e12.4)
      RETURN
      END


      SUBROUTINE EBINSNEW
      IMPLICIT REAL(A-H,O-Z)
      REAL LEINT
C
      INCLUDE 'INCLUDE/PARAM.SF'
C
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CEBINSF/TRATE,DL,DC
C
C    HEINT : THE INTERVAL AT HIGH ENERGIES OVER WHICH A FINER GRID
C            IS WANTED
C    LEINT : THE INTERVAL AT LOW ENERGIES OVER WHICH A COARSER GRID
C            IS WANTED 
C    TRATE : TRANSITION "RATE" FROM FINE TO COARSE GRID
C
      DO I=1,IMAX
        DT(I)=0.
        E(I)=0.
      ENDDO
C
      E(1)=E0
      E(NIK)=EMAX
C
      GKRIT=(EMAX-E0)/(NIK-1)
      IF (GKRIT.LE.0.5.or.nik.le.700) THEN
c      IF (GKRIT.LE.2.) THEN
C
C    IF EMAX IS LOW, USE EQUALLY SPACED ENERGY GRID
C
        DTE=(EMAX-E0)/(NIK-1)
        DO I=1,NIK-1
          DT(I)=DTE
          E(I+1)=E(I)+DT(I)
        ENDDO
      ELSE
C
C    IF EMAX HIGH (OR NIK LOW), USE FINER GRID IN THE LOW- 
C    AND HIGHENERGY PARTS AND A COARSER GRID IN BETWEEN
C
C    NF = NUMBER OF INTERVALS IN THE FINER GRID REGIONS (LOW/HIGH 
C         ENERGIES)
C
C
        HEINT=EDT+150.
        LEINT=200.
C
C  FOR THE LOW-ENERGY INTERVAL (E<200eV) THE GRIDSIZE(DT) IS 1 EV
C  DL = GRID SIZE FOR THE LOWER ENERGIES
C        
c        DL=1.5
        I=1
        DT(I)=DL
        E(I+1)=E(I)+DT(I)
  11    CONTINUE
        IF (E(I+1).LT.200.) THEN
          I=I+1
          DT(I)=DL
          E(I+1)=E(I)+DT(I)  
          GOTO 11
        ENDIF
C
C  TRANSITION REGION TO COARESER GRID, WITH 'TRANSITIONRATE' = 1.1   
C  DC = THE COARSER GRID SIZE
C
c        DC=15.
  12    CONTINUE
        IF (DT(I).LT.DC) THEN
          I=I+1
          DT(I)=DT(I-1)*1.05
          E(I+1)=E(I)+DT(I)
          GOTO 12
        ENDIF  
C
C  THE COARSE GRID REGION
C
  13    CONTINUE
        IF (E(I+1).LT.(EMAX-HEINT)) THEN              
          I=I+1
          DT(I)=DC
          E(I+1)=E(I)+DT(I)
          GOTO 13
        ENDIF
C
C  TRANSITION REGION FROM COARSER TO FINER HIGH ENERGY GRID
C  'TRANSITION RATE' = 0.9
C 
  14    CONTINUE
        DTH=(E(NIK)-E(I+1))/(NIK-I-1)        
        IF (DT(I).GT.DTH) THEN
          I=I+1
          DT(I)=DT(I-1)*0.95
          E(I+1)=E(I)+DT(I)  
          GOTO 14
        ENDIF
C
C  FINER GRID FOR HIGHER ENERGIES   
C  DH = GRID SIZE FOR THE HIGHER ENERGIES
        DH=DTH
  15    CONTINUE
        IF (I+1.LT.NIK) THEN
          I=I+1
          DT(I)=DH
          E(I+1)=E(I)+DT(I)
          GOTO 15
        ENDIF
C
      ENDIF
      DTSUM=0.
      DO I=1,IMAX
        DTSUM=DTSUM+DT(I)
      ENDDO
CJH      DTSUM=SUM(DT)
C
c      DO I=1,NIK-1
c        WRITE(6,702) I,DT(I),e(i+1)
c      ENDDO
c      WRITE(6,701) EMAX-E0,DTSUM
C
 701  FORMAT(2E12.4)
 702  FORMAT(I5,2e12.4)
      RETURN
      END

 

      SUBROUTINE ATANR
      IMPLICIT REAL(A-H,O-Z)
C
      INCLUDE 'INCLUDE/PARAM.SF'
      INCLUDE 'INCLUDE/DATIE.SF'
C
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CATAN/FATAN(MIE,IMAX)
      COMMON/CHEI/DT(IMAX),EDT,NIK
C
      DO IE=1,MIE
         DO I=1,IMAX
            FATAN(IE,I)=0.
         ENDDO
      ENDDO
      DO IE=1,IEMAX
         XIE=XI(IE)
         XJ=0.6*XIE
         DO I=1,NIK
            T=E(I)
            FATAN(IE,I)=ATAN((T-XIE)/(2.*XJ))
         ENDDO
      ENDDO
C
      RETURN
      END

      
